<?php

if (!isset($userdata)) die();

function DoCharacter($lines, &$start, $chartype = 'char')
{
	global $pid, $importcharnum;
	$queries = array('classes' => array(), 'equipment' => array());

	$relations = array(
		'TYPE' => array('field' => 'type_id', 'link' => 'd_monstertypes'),
		'RACE' => array('field' => 'race_id', 'link' => 'd_races'),
		'MONSTER' => array('field' => 'monster_id', 'link' => 'd_monsters'),
		'TEMPLATE' => array('field' => 'template_id', 'link' => 'd_templates'),
		'ATTRIBUTE' => array(
			0 => array('field' => array('str', 'drop')),
			1 => array('field' => array('dex', 'drop')),
			2 => array('field' => array('con', 'drop')),
			3 => array('field' => array('int', 'drop')),
			4 => array('field' => array('wis', 'drop')),
			5 => array('field' => array('cha', 'drop'))
		),
		'TP' => array('field' => 'hp'),
		'TW' => array('field' => 'hd'),
		'CR' => array('field' => array('cr', 'mixed_cr', 'drop')),
		'GA' => array('field' => array('ba', 'ba_epic', 'ba_size')),
		'BREAKSR' => array('field' => 'sr_break'),
		'SPEED' => array('field' => 'speed'),
		'SR' => array('field' => 'sr'),
		'SPELLFAILURE' => array('field' => 'spell_failure'),
		'ATTACKS' => array('field' => array('attacks1', 'attacks2')),
		'ATTACKSOPP' => array('field' => 'attacksopp'),
		'ARMORMALUS' => array('field' => 'armor_malus'),
		'INITIATIVE' => array('field' => array('drop', 'init_rest', 'init_dex')),
		'GAMELEE' => array('field' => array('drop', 'ba_melee_attr', 'drop', 'ba_melee_rest')),
		'GARANGE' => array('field' => array('drop', 'ba_range_attr', 'drop', 'ba_range_rest')),
		'RWREF' => array('field' => array('drop', 'st_ref_base', 'st_ref_attr', 'st_ref_mage', 'st_ref_rest')),
		'RWWIL' => array('field' => array('drop', 'st_wil_base', 'st_wil_attr', 'st_wil_mage', 'st_wil_rest')),
		'RWFORT' => array('field' => array('drop', 'st_fort_base', 'st_fort_attr', 'st_fort_mage', 'st_fort_rest')),
		'RK' => array('field' => array('drop', 'ac_armor', 'ac_shield', 'ac_dex', 'drop', 'ac_rest')),
		'FEATCOUNT' => array(),
		'SKILLS' => array(),
		'SKILLPOINTS' => array('field' => 'skillpoints'),
		'ATTACKTYPES' => array('field' => array('attack1', 'attack2')),
		'MONEY' => array('field' => array('money', 'money_left', 'sell_value', 'treasure', 'treasure_left')),
		'STARTCHARTEXT' => array('text' => 'CHARTEXTEND', 0 => 'chartext', 1 => 'chartext_primary', 2 => 'chartext_secondary', 3 => 'chartext_second'),
		'STARTFAMILIAR' => array('character' => 'familiar', 'end' => 'ENDFAMILIAR'),
		'STARTMOUNT' => array('character' => 'mount', 'end' => 'ENDMOUNT'),
		'STARTSERVANT' => array('character' => 'servant', 'end' => 'ENDSERVANT'),
		'STARTCOMPANION' => array('character' => 'companion', 'end' => 'ENDCOMPANION'),
		'FEAT' => array('list' => 'char_feats', 'field' => array('done', 'feat_id', 'reference_id'), 'link' => array('feat_id' => 'd_feats')),
		'SKILL' => array('list' => 'char_skills', 'field' => array('skill_id', 'drop', 'rank', 'bonus', 'drop', 'malus'), 'link' => array('skill_id' => 'd_skills')),
		'CLASS' => array('list' => 'char_classes', 'field' => array('class_id', 'levels', 'classic_levels', 'caster_level'), 'link' => array('class_id' => 'd_characters')),
		'SPELL' => array('default' => array('attr' => -1), 'ref' => 'classes', 'refid' => 'class_id', 'list' => 'char_spells', 'field' => array('sort', 'level', 'spell_id', 'dc'), 'link' => array('spell_id' => 'd_spells')),
		'SPELLSKNOWN' => array('default' => array('type' => 'spell'), 'table' => array('known', 'per_day'), 'ref' => 'classes', 'refid' => 'class_id', 'num' => false, 'list' => 'char_spellsknown', 'field' => array('col', 'known', 'per_day')),
		'SPECIALIZED' => array('field' => 'specialized', 'link' => 'd_schools'),
		'FORBIDDEN' => array('list' => 'char_forbidden', 'field' => 'school_id', 'link' => 'd_schools'),
		'SIZE' => array('field' => 'size_id', 'link' => 'd_size'),
		'MONSTERATTACK' => array('list' => 'char_monsterattack', 'field' => array('type', 'name', 'dmg1', 'dmg2', 'dmg3', 'attack')),
		'DOMAIN' => array('list' => 'char_domains', 'field' => array('domain_id'), 'link' => 'd_domains'),
		'ATTACKSMONK' => array('field' => 'attacksmonk'),
		'MONKDAMAGE' => array('field' => array('damagemonk1', 'damagemonk2')),
		'PSIPOINTS' => array('field' => 'psipoints'),
		'PSIDISCIPLE' => array('field' => 'psidisciple'),
		'PSIKNOWN' => array('default' => array('type' => 'power', 'row' => 0), 'list' => 'char_spellsknown', 'num' => false, 'ref' => 'classes', 'refid' => 'class_id', 'field' => array('col', 'text')),
		'PSI' => array('ref' => 'classes', 'refid' => 'class_id', 'list' => 'char_spells', 'field' => array('sort', 'level', 'dc', 'attr', 'spell_id'), 'link' => array('spell_id' => 'd_powers'))
	);

	$equip_relations = array(
		'EQUIPEFFECT' => array('ref' => 'equipment', 'refid' => 'equip_id', 'list' => 'char_equipeffects', 'field' => array('sort', 'effect_id', 'text'), 'link' => array('effect_id' => 'd_effects'), 'linkname' => array('d_effects' => 'effect')),
		'EQUIPMATERIAL' => array('field' => 'material'),
		'EQUIPMENT' => array('field' => array('equiptype', 'equip_id', 'value', 'include'), 'link' => array('equip_id' => 'd_equipment')),
		'EQUIPWEAPON' => array('field' => array('dmg1', 'dmg2', 'dmg3', 'critical1', 'critical2', 'enhence', 'effect1', 'effect2', 'attack')),
		'ATTACKSECOND' => array('field' => 'attack2'),
		'MAXSTR' => array('field' => 'max_str'),
		'EQUIPARMOR' => array('field' => array('armor', 'max_dex', 'malus', 'enhence', 'effect1', 'effect2', 'spell_failure')),
		'EQUIPSHIELD' => array('field' => array('armor', 'malus', 'enhence', 'effect1', 'effect2', 'spell_failure')),
		'EQUIPARROWS' => array('field' => array('enhence', 'effect1', 'effect2')),
		'EQUIPDESC' => array('field' => 'text'),
		'NOSHIELD' => array('field' => 'noshield')
	);

	$mode = 'char';
	$character = array();
	$ref_ids = array();
	for ($i = $start;$i < count($lines);$i++)
	{
		if ($mode == 'text')
		{
			if ($lines[$i] == $textmode['end'])
			{
				$mode = $textmode['mode'];
				$character[$textmode['var']] = implode("\n", $text);
			}
			else if ($lines[$i] != '')
			{
				$text[] = $lines[$i];
			}
		}
		else
		{
			//echo "Processing Line: $lines[$i]<br>";

			$cmd = explode('=', $lines[$i], 2);

			if (isset($require))
			{
				if ($cmd[0] != $require) trigger_error("Invalid Line: $lines[$i], $require ecspected", E_USER_ERROR);
				unset($require);
				continue;
			}

			if ($mode == 'equip' && $cmd[0] == 'EQUIPEND')
			{
				$mode = $equipmode['mode'];

				$queries[] = "INSERT INTO char_equipment (" . implode(',', mod_EscapeArray(array_keys($equip), '`', 'mysql_escape_string')) . ', character_id) VALUES (' .
					implode(',', mod_EscapeArray($equip, '"', 'mysql_escape_string'));

				continue;
			}


			if ($cmd[0] == 'ENDCHARACTER') break;
			if ($cmd[0] == 'STARTCHARACTER') continue;

			if ($cmd[0] == 'EQUIPSTART' || $cmd[0] == 'TREASURESTART')
			{
				$equip = array('sort' => $cmd[1], 'treasure' => ($cmd[0] == 'TREASURESTART' ? 1 : 0), 'text' => '-');
				$equipmode = array('type' => $cmd[0], 'num' => $cmd[1], 'mode' => 'char');
				$mode = 'equip';
				continue;
			}

			if ($mode == 'equip')
			{

				if (!isset($equip_relations[$cmd[0]])) trigger_error("Unexspected Equip Command $cmd[0] in Line $lines[$i]", E_USER_ERROR);
				$script = $equip_relations[$cmd[0]];
			}
			else
			{
				if (!isset($relations[$cmd[0]])) trigger_error("Unexspected Command $cmd[0] in Line $lines[$i]", E_USER_ERROR);
				$script = $relations[$cmd[0]];
			}
			if (count($script) == 0)
			{
				continue;
			}
			else if (isset($script['text']))
			{
				$mode = 'text';
				$text = array();
				$textmode = array('end' => $script['text'], 'mode' => 'char', 'var' => isset($script['field']) ? $script['field'] : $script[$cmd[1]]);
			}
			else if (isset($script['character']))
			{
				$i++;
				$require = str_replace('START', 'END', $script['end']);
				$ref_ids[] = DoCharacter($lines, $i, $script['character']);
			}
			else
			{
				if (!isset($script['field']))
				{
					$tmp = explode(',', $cmd[1], 2);
					$cmd[1] = $tmp[1];
					$script = $script[$tmp[0]];
				}
				if (!is_array($script['field']))
				{
					$script['field'] = array($script['field']);
				}
				$tmparray = array();

				if (isset($script['list']) && (isset($script['ref']) || !isset($script['num']) || $script['num'] === true))
				{
					$tmp = explode(',', $cmd[1], 2);
					$tmparray[isset($script['ref']) ? 'list_id' : 'sort'] = $tmp[0];
					$cmd[1] = $tmp[1];
				}
				$vals = mod_ExplodeBrackets($cmd[1], ',', count($script['field']), false);

				foreach ($script['field'] as $index => $field)
				{
					if ($field == 'drop') continue;
					$tmparray[$field] = $vals[$index];
				}

				if (isset($script['link']))
				{
					if (!is_array($script['link'])) $script['link'] = array($script['field'][0] => $script['link']);
					foreach ($script['link'] as $field => $link)
					{
						$name = isset($script['linkname']) ? $script['linkname'][$link] : 'name';
						if ($link == 'd_characters' && $tmparray[$field] == 'Spellchar')
						{
							$tmparray[$field] = 0;
						}
						else
						{
							$query = "SELECT id FROM `" . mysql_escape_string($link) . "` WHERE `" . mysql_escape_string($name) . "` = '" . mysql_escape_string($tmparray[$field]) . "'";
							$result = mod_mysql_querya($query);
							if (mysql_num_rows($result) == 0) trigger_error("Coult not find $tmparray[$field] in $link", E_USER_ERROR);
							$tmparray[$field] = mysql_result($result, 0);
						}
					}
				}

				if (isset($script['list']))
				{
					if ($cmd[0] == 'FEAT')
					{
						$tmparray['reference_id'] = substr($tmparray['reference_id'], 1);
						if ($tmparray['reference_id'] == 'Alle')
						{
							$tmparray['reference_id'] = -1;
						}
						else
						{
							$query = "SELECT dep FROM d_feats WHERE id = " . intval($tmparray['feat_id']);
							$dep = mysql_result(mod_mysql_querya($query), 0);

							if ($dep && $tmparray['reference_id'] == '')
							{
								$dep = 0;
							}

							switch ($dep)
							{
								case 0:
									$tmparray['reference_id'] = 0;
									break;

								case 1:
									$query = "SELECT d_weapons.id FROM d_equipment LEFT JOIN d_weapons ON d_weapons.name = d_equipment.id WHERE d_equipment.name = '" . mysql_escape_string($tmparray['reference_id']) . "'";
									$tmparray['reference_id'] = mysql_result(mod_mysql_querya($query), 0);
									if ($tmparray['reference_id'] == '') $tmparray['reference_id'] = 0;
									break;

								case 2:
									$query = "SELECT id FROM d_schools WHERE name = '" . mysql_escape_string($tmparray['reference_id']) . "'";
									$tmparray['reference_id'] = mysql_result(mod_mysql_querya($query), 0);
									break;


								case 3:
									$query = "SELECT id FROM d_skills WHERE name = '" . mysql_escape_string($tmparray['reference_id']) . "'";
									$tmparray['reference_id'] = mysql_result(mod_mysql_querya($query), 0);
									break;

								case 4:
									$tmparray['reference_id'] = 0;
									break;

								default:
									trigger_error("Invalid Feat Dependancy", E_USER_ERROR);
							}
						}
					}

					if (isset($script['default']))
					{
						$tmparray = array_merge($tmparray, $script['default']);
					}

					if (isset($script['ref']))
					{
						if (!isset($queries[$script['ref']])) $queries[$script['ref']] = array();
						if (!isset($queries[$script['ref']][$tmparray['list_id']])) $queries[$script['ref']][$tmpsort = $tmparray['list_id']] = array();
						unset($tmparray['list_id']);

						if (isset($script['table']))
						{
							$tmparraya = $tmparray;

							foreach ($script['table'] as $rownum => $rowentry)
							{
								$tmparray = $tmparraya;
								$tmparray['text'] = $tmparray[$rowentry];
								foreach ($script['table'] as $rowdel)
								{
									unset ($tmparray[$rowdel]);
								}
								$tmparray['row'] = $rownum;

								$tmpquery= "INSERT INTO `" . mysql_escape_string($script['list']) . "` (" .
									implode(',', mod_EscapeArray(array_keys($tmparray), '`', 'mysql_escape_string')) . ', `' . mysql_escape_string($script['refid']) . '`) VALUES (' .
									implode(',', mod_EscapeArray($tmparray, '"', 'mysql_escape_string'));

								$queries[$script['ref']][$tmpsort][] = $tmpquery;
							}
						}
						else
						{
							$tmpquery= "INSERT INTO `" . mysql_escape_string($script['list']) . "` (" .
								implode(',', mod_EscapeArray(array_keys($tmparray), '`', 'mysql_escape_string')) . ', `' . mysql_escape_string($script['refid']) . '`) VALUES (' .
								implode(',', mod_EscapeArray($tmparray, '"', 'mysql_escape_string'));

							$queries[$script['ref']][$tmpsort][] = $tmpquery;
						}
					}
					else
					{
						$tmpquery= "INSERT INTO `" . mysql_escape_string($script['list']) . "` (" .
							implode(',', mod_EscapeArray(array_keys($tmparray), '`', 'mysql_escape_string')) . ', character_id) VALUES (' .
							implode(',', mod_EscapeArray($tmparray, '"', 'mysql_escape_string'));

						$queries[] = $tmpquery;
					}
				}
				else
				{
					if ($mode == 'equip')
					{
						$equip = array_merge($equip, $tmparray);
					}
					else
					{
						$character = array_merge($character, $tmparray);
					}
				}
			}
		}
	}
	$start = $i;
	$character['char_type'] = $chartype;
	$character['name'] = ($chartype == 'char' ? 'Imported' : 'Imported (Reference)') . " ($importcharnum)";
	$query = "INSERT INTO characters (" . implode(',', mod_EscapeArray(array_keys($character), '`', 'mysql_escape_string')) . ', party_id) VALUES (' .
		implode(',', mod_EscapeArray($character, '"', 'mysql_escape_string')) . ", $pid)";
	//echo $query, '<br>';
	mod_mysql_querya($query);
	$char_id = mysql_insert_id();

	krsort($queries);

	foreach ($queries as $ref => $querya)
	{
		if (!is_array($querya)) $querya = array($querya);

		foreach ($querya as $num => $queryb)
		{
			if (!is_array($queryb)) $queryb = array($queryb);

			foreach ($queryb as $query)
			{
				if (is_numeric($ref))
				{
					$query .= ", $char_id)";
				}
				else
				{
					$tmpquery = "SELECT id FROM `char_" . mysql_escape_string($ref) . "` WHERE character_id = $char_id AND sort = " . intval($num);
					$result = mod_mysql_querya($tmpquery);
					if (mysql_num_rows($result) == 0)
					{
						trigger_error("Could not find entry $num in char_$ref", E_USER_ERROR);
					}
					else
					{
						$tmpid = mysql_result($result, 0);
					}
					$query .= ", $tmpid)";
				}
				//echo $query, '<br>';

				mod_mysql_querya($query);
			}
		}
	}
	foreach ($ref_ids as $id)
	{
		$query = "UPDATE characters SET reference_char = $char_id WHERE id = $id";
		//echo $query, '<br>';
		mod_mysql_querya($query);
	}

	//echo "Character Done<br>";
	return($char_id);
}

if (isset($_FILES['importchar']) && (!isset($_FILES['importchar']['error']) || !$_FILES['importchar']['error']) && isset($_REQUEST['party']) && $_REQUEST['party'] != '')
{
	/*$query = "SHOW TABLES";
	$result = mod_mysql_querya($query);
	while ($tmp = mysql_fetch_row($result))
	{
		if (strpos($tmp[0], 'char_') === 0 || $tmp[0] == 'characters')
		{
			$query = "TRUNCATE TABLE $tmp[0]";
			mod_mysql_querya($query);
		}
	}
	$query = "TRUNCATE TABLE parties";
	mod_mysql_querya($query);*/

	$name = $_REQUEST['party'];
	$query = "SELECT id FROM parties WHERE name = '" . mysql_escape_string($name) . "' AND campaign_id = $cid";
	$result = mod_mysql_querya($query);
	if (mysql_num_rows($result))
	{
		echo "<font style='color:red;font-weight:bold;'>That Party already exists</font><br><br>";
	}
	else
	{
		if (($file = file_get_contents($_FILES['importchar']['tmp_name'])) === false) trigger_error('Could not read Import file', E_USER_ERROR);
	
		$query = "SELECT IFNULL(MAX(sort), 0) FROM parties WHERE campaign_id = $cid";
		$sort = mysql_result(mod_mysql_querya($query), 0) + 1;

		$query = "INSERT INTO parties (campaign_id, name, sort) VALUES ($cid, '" . mysql_escape_string($name) . "', $sort)";
		mod_mysql_querya($query);
		$pid = $_REQUEST['pid'] = mysql_insert_id();

		$lines = explode("\n", str_replace("\r", '', $file));
		$importcharnum = 1;

		for ($i = 0;$i < count($lines);$i++)
		{
			if ($lines[$i] == '')
			{
				continue;
			}
			else if (strpos('STARTCHARACTER', $lines[$i]) === 0)
			{
				//echo "<b>Importing Character</b><br>Parsing Character<br>";
				$i++;
				DoCharacter($lines, $i);
				//echo "Done<br><b>Character Import successfull</b><br><br>";
				$importcharnum++;
			}
			else trigger_error("Unexspected Line: $lines[$i]", E_USER_ERROR);
		}
		echo '<b>', $importcharnum - 1, ' Characters imported successfully</b><br>';
	}
}

$classopts = mod_createselectoptions("SELECT id, name FROM d_characters WHERE dataset_id = $campaign[dataset_id]");
$featopts = mod_createselectoptions("SELECT id, name FROM d_feats WHERE dataset_id = $campaign[dataset_id]");
$skillopts = mod_createselectoptions("SELECT id, name FROM d_skills WHERE dataset_id = $campaign[dataset_id]");
$spellopts = mod_createselectoptions("SELECT id, name FROM d_spells WHERE dataset_id = $campaign[dataset_id]");
$effectopts = mod_createselectoptions("SELECT id, effect AS name FROM d_effects WHERE dataset_id = $campaign[dataset_id]");
$schoolopts = mod_createselectoptions("SELECT id, name FROM d_schools WHERE dataset_id = $campaign[dataset_id] AND name != 'Allgemein'");
$domainopts = mod_createselectoptions("SELECT id, name FROM d_domains WHERE dataset_id = $campaign[dataset_id]");
$CharTypeOptions = array('char' => 'Character', 'familiar' => 'Familiar', 'mount' => 'Paladin Mount', 'servant' => 'Fiendish Servant', 'companion' => 'Animal Companion');

if (isset($_REQUEST['displayparty']) && mod_CheckTableId('parties', $pid = intval($_REQUEST['displayparty'])))
{
	$name = mod_GetTableNameFromId('parties', $pid);
	echo "<center><font style='font-size:22px;color:green;font-weight:bold;'>Party: <u>$name</u></font> <i>(<a href='$modules_defaults[defaultlink]&pid=$pid'>Edit</a>)</i></center><br>";

	$query = "SELECT id, name FROM characters WHERE party_id = $pid AND char_type = 'char'";
	$result = mod_mysql_querya($query);
	$chars = array();
	while ($tmp = mysql_fetch_assoc($result))
	{
		ob_start();
		DisplayChar($tmp['id']);
		$chars[$tmp['name']] = ob_get_clean();
	}
	echo '<br>';
	$view = new multiview;
	$view->data = $chars;
	$view->type = 0;
	$view->defaultlink = $modules_defaults['defaultlink'] . '&displayparty=' . $pid;
	CreateMultiView($view);
}
else if (isset($_REQUEST['pid']) && mod_CheckTableId('parties', $pid = intval($_REQUEST['pid'])))
{
	mod_autoindex('pid', 0);
	mod_addDefaultLink('pid');

	$name = mod_GetTableNameFromId('parties', $pid);
	echo "<center><font style='font-size:22px;color:green;font-weight:bold;'>Party: <u>$name</u></font> <i>(<a href='$modules_defaults[defaultlink]&displayparty=$pid'>Display</a>)</i></center><br>";

	$edit = new sqledit;
	$edit->sqltablename = 'characters';
	$edit->adddefaults['party_id'] = $pid;
	$edit->sqlwhere = '';
	$edit->sortable = false;
	$edit->relations = array(
		'name' => array('name' => 'Name', 'force' => true, 'nodual' => "party_id = $pid"),
		'cr' => array('group' => true, 'name' => 'CR', 'formname' => 'Challenge Rating', 'type' => 'int', 'force' => 1),
		'mixed_cr' => array('group' => false, 'name' => 'Mixed CR', 'type' => 'int', 'force' => 1, 'hide' => true),
		'char_type' => array('name' => 'Character Type', 'type' => 'select', 'options' => $CharTypeOptions),
		'reference_char' => array('name' => 'Reference char', 'type' => 'select', 'options' => "SELECT id, name FROM characters WHERE party_id = $pid", 'zeroopt' => 'No Reference'),
		'type_id' => array('name' => 'Type', 'type' => 'select', 'options' => "SELECT id, name FROM d_monstertypes WHERE dataset_id = $campaign[dataset_id]"),
		'race_id' => array('name' => 'Race', 'type' => 'select', 'options' => "SELECT id, name FROM d_races WHERE dataset_id = $campaign[dataset_id]", 'zeroopt' => 'Monster'),
		'monster_id' => array('name' => 'Monster', 'type' => 'select', 'options' => "SELECT id, name FROM d_monsters WHERE dataset_id = $campaign[dataset_id]", 'zeroopt' => 'None'),
		'template_id' => array('name' => 'Template', 'type' => 'select', 'options' => "SELECT id, name FROM d_templates WHERE dataset_id = $campaign[dataset_id]", 'zeroopt' => 'None'),
		'size_id' => array('name' => 'Size', 'type' => 'select', 'options' => "SELECT id, name FROM d_size WHERE dataset_id = $campaign[dataset_id]"),
		'feats' => array('name' => 'Feats', 'sql' => 1, 'type' => 'multi', 'sqllink' => 'char_feats', 'sqllinknums' => 'sort', 'multilink' => true,
			'sqllinkdata' => array('character_id' => '[ID]', 'feat_id' => '[LINK0]', 'reference_id' => '[LINK1]', 'done' => '[LINK2]'),
			'multitextselects' => array(0, 2), 'multitexthtml' => "Feat: <select name=\"[NAME][0]\">$featopts</select> Reference: <input name=\"[NAME][1]\" size=3> Done: <select name=\"[NAME][2]\"><option value=\"0\">Not Done</option><option value=\"1\">Done</option></select>"),
		'skills' => array('name' => 'Skills', 'sql' => 1, 'type' => 'multi', 'sqllink' => 'char_skills', 'sqllinknums' => 'sort', 'multilink' => true,
			'sqllinkdata' => array('character_id' => '[ID]', 'skill_id' => '[LINK0]', 'rank' => '[LINK1]', 'bonus' => '[LINK2]', 'malus' => '[LINK3]'),
			'multitextselects' => array(0), 'multitexthtml' => "Feat: <select name=\"[NAME][0]\">$skillopts</select> Rank: <input name=\"[NAME][1]\" size=1> Bonus: <input name=\"[NAME][2]\" size=1> Malus: <input name=\"[NAME][3]\" size=1>"),
		'hp' => array('group' => true, 'name' => 'HP', 'formname' => 'Hitpoints', 'type' => 'int', 'force' => true),
		'hd' => array('group' => false, 'name' => 'Hit Dice', 'type' => 'int', 'force' => true, 'hide' => true),
		'str' => array('group' => 'Strength', 'name' => 'Str', 'formname' => 'Attributes', 'type' => 'int', 'force' => 1),
		'dex' => array('name' => 'Dex', 'formname' => 'Dexterity', 'type' => 'int', 'force' => 1),
		'con' => array('name' => 'Con', 'formname' => 'Constitution', 'type' => 'int', 'force' => 1),
		'int' => array('name' => 'Int', 'formname' => 'Inteligence', 'type' => 'int', 'force' => 1),
		'wis' => array('name' => 'Wis', 'formname' => 'Wisdom', 'type' => 'int', 'force' => 1),
		'cha' => array('group' => false, 'name' => 'Cha', 'formname' => 'Charisma', 'type' => 'int', 'force' => 1),
		'ba' => array('group' => 'Base Attack', 'name' => 'Attack Bonus', 'type' => 'int', 'force' => 1, 'sql' => 'ba + ba_epic'),
		'ba_epic' => array('name' => 'Epic Attack', 'type' => 'int', 'force' => 1, 'hide' => true),
		'ba_size' => array('group' => false, 'name' => 'Size Modifier', 'type' => 'int', 'force' => 1, 'hide' => true),
		'ba_melee_attr' => array('group' => true, 'name' => 'Melee Attack Attribute Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'ba_melee_rest' => array('name' => 'Melee Attack Other Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'ba_range_attr' => array('name' => 'Range Attack Attribute Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'ba_range_rest' => array('group' => false, 'name' => 'Range Attack Other Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_ref_base' => array('group' => 'Base', 'name' => 'Reflex Save', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_ref_attr' => array('name' => 'Attr. Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_ref_mage' => array('name' => 'Mage Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_ref_rest' => array('group' => false, 'name' => 'Other Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_wil_base' => array('group' => 'Base', 'name' => 'Will Save', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_wil_attr' => array('name' => 'Attr. Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_wil_mage' => array('name' => 'Mage Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_wil_rest' => array('group' => false, 'name' => 'Other Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_fort_base' => array('group' => 'Base', 'name' => 'Fortitude Save', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_fort_attr' => array('name' => 'Attr. Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_fort_mage' => array('name' => 'Mage Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'st_fort_rest' => array('group' => false, 'name' => 'Other Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'skillpoints' => array('name' => 'Skillpoints', 'type' => 'int', 'force' => 1, 'hide' => true),
		'init_dex' => array('group' => true, 'name' => 'Init.', 'formname' => 'Initiative Attribute Mod.', 'type' => 'int', 'force' => 1, 'sql' => 'init_dex + init_rest'),
		'init_rest' => array('group' => false, 'name' => 'Initiative Other Mod.', 'type' => 'int', 'force' => 1, 'hide' => true),
		'speed' => array('name' => 'Speed', 'force' => true, 'default' => '9'),
		'sr' => array('group' => true, 'name' => 'SR', 'formname' => 'Spell Resistance', 'type' => 'int', 'force' => 1),
		'sr_break' => array('name' => 'Break Spell Resistance', 'force' => 1, 'type' => 'int', 'hide' => true),
		'spell_failure' => array('group' => false, 'name' => 'Spell Failure', 'type' => 'int', 'force' => 1, 'hide' => true),
		'psipoints' => array('group' => true, 'name' => 'Psi Points', 'type' => 'int', 'force' => 1, 'hide' => true),
		'psidisciple' => array('group' => false, 'name' => 'Psi Disciple', 'type' => 'select', 'hide' => true, 'options' => array(-1 => 'None') + $AttributeOptions),
		'attack1' => array('group' => true, 'name' => 'Attack 1', 'formname' => 'Primary Attack Type', 'type' => 'select', 'options' => array_merge(array(0 => 'Fist'), $AttackOptions, array(5 => 'Monster'))),
		'attack2' => array('group' => false, 'name' => 'Attack 2', 'formname' => 'Secondary Attack Type', 'type' => 'select', 'options' => array_merge(array(0 => 'None'), $AttackOptions, array(5 => 'Monster'))),
		'attacks1' => array('group' => true, 'name' => 'Attacks', 'formname' => 'Attacks (Primary Attack)', 'type' => 'int', 'force' => 1, 'sql' => "IF(race_id=0,'Monster',CONCAT(attacks1, ' / ', attacks2))"),
		'attacks2' => array('name' => 'Attacks (Secondary Attack)', 'type' => 'int', 'force' => 1, 'hide' => true),
		'attacksopp' => array('group' => false, 'name' => 'Attacks of Opportunity', 'type' => 'int', 'force' => true, 'hide' => true),
		'monsterattack' => array('name' => 'Monster Attacks', 'hide' => 'true', 'type' => 'multi', 'sqllink' => 'char_monsterattack', 'sqllinknums' => 'sort', 'multilink' => true,
			'sqllinkdata' => array('character_id' => '[ID]', 'type' => '[LINK0]', 'name' => '[LINK1]', 'dmg1' => '[LINK2]', 'dmg2' => '[LINK3]', 'dmg3' => '[LINK4]', 'attack' => '[LINK5]'),
			'multitexthtml' => 'Type: <input name="[NAME][0]" size=5> Name: <input name="[NAME][1]" size=4> Damage: <input name="[NAME][2]" size=1> W <input name="[NAME][3]" size=1> + <input name="[NAME][4]" size=1> Attack: <input name="[NAME][5]" size=2>'),
		'attacksmonk' => array('group' => true, 'name' => 'Attacks Fist (Monk)', 'hide' => true, 'force' => 1, 'type' => 'int'),
		'damagemonk1' => array('name' => 'Damage (Monk) 1', 'hide' => true, 'force' => 1, 'type' => 'int'),
		'damagemonk2' => array('group' => false, 'name' => 'Danage (Monk) 2', 'hide' => true, 'force' => 1, 'type' => 'int'),
		'ac_armor' => array('group' => true, 'name' => 'AC', 'formnaem' => 'AC (Armor)', 'type' => 'int', 'force' => 1, 'sql' => '10 + ac_armor + ac_shield + ac_dex + ac_rest + ba_size'),
		'ac_shield' => array('name' => 'AC (Shield)', 'type' => 'int', 'force' => 1, 'hide' => true),
		'ac_dex' => array('name' => 'AC (Attribute)', 'type' => 'int', 'force' => 1, 'hide' => true),
		'ac_rest' => array('name' => 'AC (Rest)', 'type' => 'int', 'force' => 1, 'hide' => true),
		'armor_malus' => array('group' => false,'name' => 'Armor Malus', 'type' => 'int', 'force' => 1, 'hide' => true),
		'specialized' => array('group' => true, 'name' => 'Specialized', 'type' => 'select', 'options' => "SELECT id, name FROM d_schools WHERE dataset_id = $campaign[dataset_id] AND name != 'Allgemein'", 'zeroopt' => 'Not Specialized'),
		'forbidden' => array('hide' => true, 'name' => 'Forbidden Schools', 'type' => 'multi', 'sqllink' => 'char_forbidden', 'sqllinknums' => 'sort', 'multitextselects' => 1,
			'sqllinkdata' => array('character_id' => '[ID]', 'school_id' => '[LINK]'), 'multitexthtml' => "<select name=\"[NAME]\">$schoolopts</select>"),
		'domains' => array('group' => false, 'hide' => true, 'name' => 'Domains', 'type' => 'multi', 'sqllink' => 'char_domains', 'sqllinknums' => 'sort', 'multitextselect' => 1,
			'sqllinkdata' => array('character_id' => '[ID]', 'domain_id' => '[LINK]'), 'multitexthtml' => "<select name=\"[NAME]\">$domainopts</select>"),
		'money' => array('group' => true, 'name' => 'Money', 'type' => 'int', 'force' => 1, 'hide' => true),
		'money_left' => array('name' => 'Money Left', 'type' => 'int', 'force' => 1, 'hide' => true),
		'sell_value' => array('name' => 'Sell Value', 'type' => 'int', 'force' => 1, 'hide' => true),
		'treasure' => array('name' => 'Treasure', 'type' => 'int', 'force' => 1, 'hide' => true),
		'treasure_left' => array('group' => false, 'name' => 'Treasure Left', 'type' => 'int', 'force' => 1, 'hide' => true),
		'chartext' => array('name' => 'Character Text', 'rows' => 10, 'hide' => true),
		'chartext_primary' => array('name' => 'Character Text (Primary Attack)', 'rows' => 3, 'hide' => true),
		'chartext_secondary' => array('name' => 'Character Text (Secondary Attack)', 'rows' => 3, 'hide' => true),
		'chartext_second' => array('name' => 'Character Text (Second Weapon)', 'rows' => 3, 'hide' => true),
		'classes' => array('name' => 'Classes', 'sql' => '1', 'type' => 'multi', 'sqllink' => 'char_classes', 'sqllinknums' => 'sort', 'multilink' => true,
			'sqllinkdata' => array('character_id' => '[ID]', 'class_id' => '[LINK0]', 'levels' => '[LINK1]', 'classic_levels' => '[LINK2]', 'caster_level' => '[LINK3]'),
			'multitextselects' => array(0), 'multitexthtml' => "Class: <select name=\"[NAME][0]\">$classopts<option value=\"0\">Monster Spellchar</option></select> Level: <input name=\"[NAME][1]\" size=3> Classic Level <input name=\"[NAME][2]\">" .
				" Caster Level: <input name=\"[NAME][3]\" size=3>", 'requireedit' => false),
	);
	$edit->title = 'Characters';
	$edit->name = 'Character';
	$edit->width = '100%';

	$editclasses = new sqledit;
	$editclasses->title = 'Classes';
	$editclasses->name = 'Class';
	$editclasses->sqltablename = 'char_classes';
	$editclasses->relations = array(
		'class_id' => array('name' => 'Class', 'type' => 'select', 'default' => -1, 'options' => "(SELECT id, name FROM d_characters WHERE dataset_id = $campaign[dataset_id]) UNION (SELECT 0 AS id, 'Monster Spellchar' AS Name)"),
		'levels' => array('name' => 'Levels', 'type' => 'int', 'force' => true),
		'classic_levels' => array('name' => 'Levels (Classic)', 'type' => 'int', 'force' => 1),
		'caster_level' => array('name' => 'Caster Level', 'type' => 'int', 'force' => 1),
		'spellsknown' => array('numerictable' => 1, 'name' => 'Spells / Power Known / Per Day', 'hide' => true, 'type' => 'table', 'tablesqltable' => 'char_spellsknown', 'tableconstants' => array('class_id' => '[ID]'),
			'tabletitles' => array(array('Spells&nbsp;/&nbsp;Powers&nbsp;Known', 'Spells&nbsp;per&nbsp;Day'), array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9)), 'rows' => 2, 'cols' => 10, 'tablefixed' => true)
	);
	$edit->subedits['character_id'] = array($editclasses);

	$editequip = new sqledit;
	$editequip->title = 'Equipment';
	$editequip->name = 'Item';
	$editequip->sqltablename = 'char_equipment';
	$editequip->relations = array(
		'equiptype' => array('name' => 'Equipment Type', 'type' => 'select', 'options' => $FullEquipTypeOptions),
		'equip_id' => array('name' => 'Equipment', 'type' => 'select', 'options' => "SELECT id, name FROM d_equipment WHERE dataset_id = $campaign[dataset_id]", 'zeroopt' => 'User Defined'),
		'value' => array('name' => 'Value', 'type' => 'int', 'force' => 1),
		'treasure' => array('name' => 'Treasure', 'type' => 'checkbox'),
		'attack' => array('name' => 'Attack', 'type' => 'int', 'force' => 1, 'signed' => true, 'sql' => "CONCAT(attack, IF(attack2!=0,CONCAT(' / ', attack2),''))"),
		'attack2' => array('name' => 'Attack 2 (Doubleblade)', 'type' => 'int', 'force' => 1, 'hide' => true),
		'dmg1' => array('name' => 'Damage 1', 'type' => 'int', 'force' => 1, 'sql' => "CONCAT(dmg1, 'W', dmg2, ' + ', dmg3)"),
		'dmg2' => array('name' => 'Damage 2', 'type' => 'int', 'force' => 1, 'hide' => true),
		'dmg3' => array('name' => 'Damage 3', 'type' => 'int', 'force' => 1, 'hide' => true),
		'critical1' => array('name' => 'Critical', 'formname' => 'Critical Threat', 'type' => 'int', 'force' => 1, 'sql' => "CONCAT(critical1, '-20 / ', critical2)"),
		'critical2' => array('name' => 'Critical Multiplier', 'type' => 'int', 'force' => 1, 'hide' => true),
		'enhence' => array('name' => 'Enhencement', 'type' => 'int', 'force' => 1),
		'effect1' => array('name' => 'Effects', 'formname' => 'Enhencement quivalent Effect', 'type' => 'int', 'force' => 1, 'sql' => "CONCAT(effect1, ' (', effect2, ')')"),
		'effect2' => array('name' => 'Effects', 'type' => 'int', 'force' => 1, 'hide' => true),
		'material' => array('name' => 'Material', 'type' => 'select', 'options' => $MaterialOptions),
		'max_str' => array('name' => 'Max. Str. Bonus', 'type' => 'int', 'force' => 1, 'hide' => true),
		'armor' => array('name' => 'AC', 'type' => 'int', 'force' => 1),
		'max_dex' => array('name' => 'Max. Dex.', 'formname' => 'Max. Dex. Bonus', 'type' => 'int', 'force' => 1),
		'malus' => array('name' => 'Armor Malus', 'type' => 'int', 'force' => 1),
		'spell_failure' => array('name' => 'Spell Failure', 'type' => 'int', 'force' => 1),
		'include' => array('name' => 'Inc.', 'type' => 'checkbox'),
		'noshield' => array('name' => 'No Shield', 'hide' => true, 'type' => 'checkbox'),
		'text' => array('name' => 'Text', 'rows' => 3, 'hide' => true),
		'effects' => array('name' => 'Effects', 'hide' => true, 'type' => 'multi', 'sqllink' => 'char_equipeffects', 'sqllinkdata' => array('equip_id' => '[ID]', 'effect_id' => '[LINK0]', 'text' => '[LINK1]'),
			'multilink' => true, 'sqllinknums' => 'sort', 'multitextselects' => array(0), 'multitexthtml' => "Effect: <select name=\"[NAME][0]\">$effectopts</select> Text: <input name=\"[NAME][1]\">")
	);
	$edit->subedits['character_id'][] = $editequip;

	CreateSqlEdit($edit);
}
else
{
	$edit = new sqledit;
	$edit->title = 'Parties';
	$edit->name = 'Party';
	$edit->sqltablename = 'parties';
	$edit->relations = array(
		'name' => array('name' => 'Party Name', 'force' => true, 'nodual' => true, 'link' => $modules_defaults['defaultlink'] . "&pid=[ID]"),
		'display' => array('name' => 'Display', 'type' => 'virtual', 'sql' => 'CONCAT("<a href=\'' . mysql_escape_string($modules_defaults['defaultlink']) . '&displayparty=", id, "\'>Display</a>")'),
		'stats' => array('name' => 'Show in Stats', 'type' => 'select', 'options' => array(0 => 'Do not show', 1 => 'Show in Master Stats / Full Stats only', 2 => 'Always show'))
	);
	$edit->adddefaults['campaign_id'] = $cid;
	$edit->sqlwhere = '';
	$edit->sortable = true;
	CreateSqlEdit($edit);

	echo '<br><hr><br>' . mod_linkToForm('index.php' . $modules_defaults['defaultlink'], '', 'POST', "enctype='multipart/form-data'") .
	"<table>
	<tr><td>Party Name:</td><td><input name=party size=30></td></tr>
	<tr><td>Import File:</td><td><input type=file name=importchar></td></tr>
	</table>
	<input type=submit value=Import></form>";
}

?>
