<?php

ob_start();
$mod_use = array(
	'sql' => array('localhost', 'campaign', '', 'campaign'),
);

require 'pw.php';
require 'modules/modules.php';
require 'funcs.php';

if (!isset($_REQUEST['cstats'])) die('No campaign set');
$cid = intval($_REQUEST['cstats']);
if (!mod_checkTableID('campaigns', $cid)) die('Campaign not present');

$query = "SELECT * FROM campaigns WHERE id = $cid";
$campaign = mysql_fetch_assoc(mod_mysql_querya($query));
if ($campaign['stats'] == 0 && $campaign['user_id'] != $userdata['id']) die('No Stats allowed');

$graph = new graph;
//$graph->equaldist = true;
$query = "SELECT time FROM log LEFT JOIN log_param ON log_id = log.id AND (INSTR(name, '-player_id') > 0 OR INSTR(name, 'playerdamage') > 0 OR name = '[setstate]' OR name = '[use]' OR name = '[sell]') WHERE log.param = $cid AND log_param.id IS NOT NULL GROUP BY time ORDER BY time ASC";
$graph->rescale = mod_Query2Array($query, false, 0);
$graph->names[0] = 'Playtime in hours';

if (isset($_GET['log10']))
{
	$graph->scaler_type = 'log';
	$graph->cutvals[0] = $_REQUEST['gtype'] == 'money' ? 1 : ($_REQUEST['gtype'] == 'items' ? 10000 : 50000);
}

if (isset($_REQUEST['big']))
{
	$graph->sizex = 2048;
	$graph->sizey = 1536;
}

$defarray = array(strtotime('2006-05-1') => 0);
//$defarray = array();

switch($_REQUEST['gtype'])
{
	case 'playtime':
		$query = "SELECT time FROM log LEFT JOIN log_param ON log_id = log.id AND (INSTR(name, '-player_id') > 0 OR name = '[setstate]' OR name = '[use]' OR name = '[sell]') WHERE log.param = $cid AND log_param.id IS NOT NULL GROUP BY time ORDER BY time ASC";
		$times = mod_Query2Array($query, false, 0);

		$query = "SELECT time FROM log WHERE param = $cid GROUP BY time ORDER BY time ASC";
		$times2 = mod_Query2Array($query, false, 0);

		$tmptime1 = $tmptime2 = array();
		$graph->rescale = false;

		$query = "SELECT MIN(time) FROM log";
		$mintime = mysql_result(mod_mysql_querya($query), 0);

		$query = "SELECT MAX(time) FROM log";
		$maxtime = mysql_result(mod_mysql_querya($query), 0);

		$playtime = $preperationtime = $fulltime = array();

		$index1 = $index2 = 0;

		for ($i = $mintime + 3600 * 24;$i < $maxtime + 3600 * 24;$i += 3600 * 24)
		{
			while ($index1 < count($times) && $times[$index1] < $i)
			{
				$tmptime1[] = $times[$index1++];
			}
			while ($index2 < count($times2) && $times2[$index2] < $i)
			{
				$tmptime2[] = $times2[$index2++];
			}

			$time1 = array_keys(mod_ReScaleArray(array($mintime => 0, $i => 0), $tmptime1));
			$time2 = array_keys(mod_ReScaleArray(array($mintime => 0, $i => 0), $tmptime2));

			$curtime = ($i - $mintime) / 3600 / 24;
			$playtime[$curtime] = $time1[1];
			$preperationtime[$curtime] = $time2[1] - $time1[1];
			$fulltime[$curtime] = $time2[1];
		}

		$graph->data = array('Playtime' => $playtime, 'Preperationtime' => $preperationtime, 'Full Time' => $fulltime);
		$graph->multidata = true;
		$graph->names = array('Time in Days', 'Playtime in Hours');
		
		break;

	case 'damage':
		$query = "SELECT * FROM players WHERE deleted = 0 AND campaign_id = $cid AND active = 1";
		$players = mod_Query2Array($query, false, false);
		foreach ($players as $player)
		{
			$damage = 0;
			$query = "SELECT
					log.time as timestamp,
					playeroldhp.value - playerhp.value + playerdamage.value AS damage
				FROM
					log
				LEFT JOIN log_param AS playeroldhp
					ON log.id = playeroldhp.log_id AND playeroldhp.name = '[playeroldhp$player[id]]'
				LEFT JOIN log_param AS playerhp
					ON log.id = playerhp.log_id AND playerhp.name = '[playerhp$player[id]]'
				LEFT JOIN log_param AS playerdamage
					ON log.id = playerdamage.log_id AND playerdamage.name = '[playerdamage$player[id]]'
				WHERE
					log.param = $cid AND playeroldhp.id IS NOT NULL AND playerhp.id IS NOT NULL AND playerdamage.id IS NOT NULL AND playeroldhp.value - playerhp.value + playerdamage.value > 0
			";
			
			$result = mod_mysql_querya($query);
			while ($tmp = mysql_fetch_assoc($result))
			{
				$damage += $tmp['damage'];
				$graph->data[$player['name']][$tmp['timestamp']] = $damage;
			}
		}
		$graph->multidata = true;
		$graph->names[1] = 'Damage Taken';
		break;

	case 'money':
		$query = "SELECT MIN(timestamp) FROM money WHERE campaign_id = $cid AND timestamp > 0";
		$mintime = mysql_result(mod_mysql_querya($query), 0) - 100;
		$query = "SELECT SUM(money) as money, timestamp FROM money WHERE campaign_id = $cid GROUP BY timestamp ORDER BY timestamp ASC";
		$result = mod_mysql_querya($query);
		$moneys = $defarray;
		$money = 0;
		while ($tmp = mysql_fetch_assoc($result))
		{
			$moneys[max($mintime, $tmp['timestamp'])] = max(0, $money += $tmp['money']);
		}

		$graph->data = $moneys;
		$graph->multidata = 0;
		$graph->names[1] = 'Money (Current)';
		break;

	case 'money2':
		$query = "SELECT * FROM money WHERE campaign_id = $cid ORDER BY timestamp ASC";
		$result = mod_mysql_querya($query);
		$gained = $spent = $sold = $found = $defarray;
		$mgained = $mspent = $msold = $mfound = 0;
		while ($tmp = mysql_fetch_assoc($result))
		{
			if ($tmp['money'] > 0)
			{
				$mgained += $tmp['money'];
				$gained[$tmp['timestamp']] = $mgained;
				if ($tmp['item_id'])
				{
					$msold += $tmp['money'];
					$sold[$tmp['timestamp']] = $msold;
				}
				else
				{
					$mfound += $tmp['money'];
					$found[$tmp['timestamp']] = $mfound;
				}
			}
			else
			{
				$mspent -= $tmp['money'];
				$spent[$tmp['timestamp']] = $mspent;
			}
		}
		$graph->data = array('Gained' => $gained, 'Found' => $found, 'Sold' => $sold, 'Spent' => $spent);
		$graph->multidata = true;
		$graph->names[1] = 'Money (Extended)';
		break;

	case 'goods':
		$query = "SELECT * FROM money WHERE campaign_id = $cid AND money > 0 AND item_id = 0 ORDER BY timestamp ASC";
		$moneys = mod_Query2Array($query, false, false);

		$query = "SELECT * FROM items WHERE campaign_id = $cid AND deleted = 0 AND bought = 0 ORDER BY timestamp ASC";
		$items = mod_Query2Array($query, false, false);

		$i = $j = 0;
		$regular = $bonus = $full = $defarray;
		$mregular = $mbonus = $mfull = 0;
		while ($i < count($moneys) || $j < count($items))
		{
			if ($i < count($moneys) && ($j >= count($items) || $moneys[$i]['timestamp'] <= $items[$j]['timestamp']))
			{
				$tmpmoney = $moneys[$i]['money'];
				$tmpbonus = $moneys[$i]['bonus'];
				$tmptimestamp = $moneys[$i++]['timestamp'];
			}
			else
			{
				$tmpmoney = $items[$j]['value'] * $items[$j]['amount'];
				$tmpbonus = $items[$j]['bonus'];
				$tmptimestamp = $items[$j++]['timestamp'];
			}

			$mfull += $tmpmoney;
			$full[$tmptimestamp] = $mfull;
			if ($tmpbonus)
			{
				$mbonus += $tmpmoney;
				$bonus[$tmptimestamp] = $mbonus;
			}
			else
			{
				$mregular += $tmpmoney;
				$regular[$tmptimestamp] = $mregular;
			}
		}
		$graph->data = array('Full' => $full, 'Regular' => $regular, 'Bonus' => $bonus);
		$graph->multidata = true;
		$graph->names[1] = 'Full Value Gained';
		break;

	case 'xp':
		$query = "SELECT SUM(xp) as xp, timestamp FROM xp WHERE campaign_id = $cid " . ($campaign['group_xp'] == 2 ? ' AND player_id = 0' : '') . " GROUP BY timestamp ORDER BY timestamp ASC";
		$result = mod_mysql_querya($query);
		$xps = $xps2 = $xps3 = $defarray;
		$xp = $xp2 = $xp3 = 0;
		while ($tmp = mysql_fetch_assoc($result))
		{
			$xps[$tmp['timestamp']] = -($xp += min(0, $tmp['xp']));
			$xps2[$tmp['timestamp']] = ($xp2 += max(0, $tmp['xp']));
			$xps3[$tmp['timestamp']] = ($xp3 += $tmp['xp']);
		}

		$graph->data = array('Lost' => $xps, 'Gained' => $xps2, 'Current' => $xps3);
		$graph->multidata = array('Lost' => 65536 * 255, 'Gained' => 256 * 255, 'Current' =>255);
		$graph->names[1] = 'Experience';
		break;

	case 'lvl':
		$query = "SELECT players.* FROM players LEFT JOIN xp ON player_id = players.id WHERE players.campaign_id = $cid AND (players.active = 1 OR xp.id IS NOT NULL) AND deleted = 0";
		$players = mod_Query2Array($query);
		$arrays = array();
		foreach ($players as $player)
		{
			$curxp = 0;
			$tmparray = $defarray;
			$query = "SELECT * FROM xp WHERE campaign_id = $cid AND (player_id = 0 OR player_id = $player[id]) ORDER BY timestamp ASC";
			$result = mod_mysql_querya($query);
			while ($tmp = mysql_fetch_assoc($result))
			{
				$curxp += $tmp['xp'];
				$tmparray[$tmp['timestamp']] = XP2Lvl($curxp);
			}
			$arrays[$player['name']] = $tmparray;
		}
		$graph->data = $arrays;
		$graph->multidata = true;
		$graph->names[1] = 'Level';
		break;

	case 'story':
		$query = "SELECT * FROM story WHERE state > 1 ORDER BY state_timestamp ASC";
		$result = mod_mysql_querya($query);
		$storydone = $storyfailed = $storyobs = $defarray;
		$states = array(2 => 0, 3 => 0, 4 => 0);
		while ($tmp = mysql_fetch_assoc($result))
		{
			$states[$tmp['state']]++;
			$storydone[$tmp['state_timestamp']] = $states[2];
			$storyfailed[$tmp['state_timestamp']] = $states[3];
			$storyobs[$tmp['state_timestamp']] = $states[4];
		}
		$graph->data = array('Done' => $storydone, 'Failed' => $storyfailed, 'Obsolete' => $storyobs);
		$graph->multidata = array('Done' => 256 * 255, 'Failed' => 65536 * 255, 'Obsolete' => 255);
		$graph->names[1] = 'Story Elements';
		break;

	case 'items':
		$query = "SELECT players.* FROM players LEFT JOIN possession ON player_id = players.id WHERE players.campaign_id = $cid AND possession.id IS NOT NULL GROUP BY players.id";
		$players = mod_Query2Array($query, false, false, MYSQL_ASSOC);
		$players[] = array('id' => 0, 'name' => 'Group');

		$query = "SELECT start FROM possession WHERE campaign_id = $cid ORDER BY start ASC";
		$result = mod_mysql_querya($query);
		$data = array();
		while ($tmp = mysql_fetch_assoc($result))
		{
			foreach ($players as $player)
			{
				if (!isset($_GET['validplayers']) || in_array($player['id'], explode(',', $_GET['validplayers'])))
				{
					$query = "SELECT
							IFNULL(SUM(items.value * items.amount), 0)
						FROM possession
						LEFT JOIN items ON item_id = items.id
						WHERE possession.player_id = $player[id] AND start <= $tmp[start] AND (`end` > $tmp[start] OR (end = 0 AND items.sold = 0 AND items.player_id = $player[id] AND deleted = 0))";
					$result2 = mysql_result(mod_mysql_querya($query), 0);

					$query = "SELECT
							IFNULL(SUM(items.value * items.amount), 0)
						FROM items
						LEFT JOIN possession ON item_id = items.id AND possession.player_id = $player[id] AND possession.start <= $tmp[start] AND (possession.`end` > $tmp[start] OR end = 0)
						WHERE possession.id IS NULL AND items.player_id = $player[id] AND items.sold = 0 AND items.deleted = 0 AND items.campaign_id = $cid AND items.timestamp <= $tmp[start]";
					$result3 = mysql_result(mod_mysql_querya($query), 0);

					if (!isset($data[$player['name']])) $data[$player['name']] = $defarray;
					$data[$player['name']][$tmp['start']] = $result2 + $result3;
				}
			}
		}
		$graph->data = $data;
		$graph->multidata = true;
		$graph->names[1] = 'Item Value';
		break;

	default:
		unset($graph);
		break;
}

if (!isset($graph)) die('Invalid Type');
if (isset($_GET['log10'])) $graph->names[1] .= ' (log)';
echo CreateGraph($graph);

?>
