<?php

ob_start();

function cidcallback()
{
	global $index, $cid;
	return($index == 'campaign' ? $cid : 0);
}

$mod_use = array(
	'sql' => array('localhost', 'campaign', '', 'campaign'),
	'menupreurl' => '&setindex=',
	'autoindexes' => array('index' => '', 'subindex' => '', 'cid' => 0, 'sroot' => -1),
	'autosetup' => true,
	'useset' => 'qon',
	'usertimeout' => 120 * 60,
	'log_param_name' => 'cidcallback',
	'ssllogin' => 1
);
require_once 'pw.php';
require_once 'modules/modules.php';
require_once 'include.php';
require_once 'funcs.php';
require_once 'campaignfuncs.php';

$cid = intval($cid);

switch ($index)
{
	case 'useredit':
		if (mod_user_defaultcallback('admin') === true) CreateUserEdit($user);
		break;

	case 'rightsedit':
		if (mod_user_defaultcallback('root') === true) CreateRightsEdit($user);
		break;

	case 'cleanup':
		if (mod_user_defaultcallback('root') !== true) break;
		if (isset($_GET['docleanup']))
		{
			$queries = array();
			$queries[] = "DELETE FROM d_abbilities WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_boni WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_characters WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_domains WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_effects WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_equipment WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_feats WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_monsters WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_monstertext WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_monstertypes WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_powers WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_profiles WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_races WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_realnames WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_regions WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_schools WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_size WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_skills WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_specials WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_specific WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_spells WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_spells2 WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_startmoney WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_templates WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_treasure WHERE dataset_id NOT IN (SELECT id FROM datasets)";
			$queries[] = "DELETE FROM d_weapons WHERE dataset_id NOT IN (SELECT id FROM datasets)";

			$queries[] = "DELETE FROM d_monster_attacks WHERE monsters_id NOT IN (SELECT id FROM d_monsters)";
			$queries[] = "DELETE FROM d_monster_feats WHERE monsters_id NOT IN (SELECT id FROM d_monsters)";
			$queries[] = "DELETE FROM d_monster_skills WHERE monsters_id NOT IN (SELECT id FROM d_monsters)";

			$queries[] = "DELETE FROM d_profiles_classes WHERE profile_id NOT IN (SELECT id FROM d_profiles)";
			$queries[] = "DELETE FROM d_profiles_links WHERE profile_id NOT IN (SELECT id FROM d_profiles)";
			$queries[] = "DELETE FROM d_profiles_skills WHERE profile_id NOT IN (SELECT id FROM d_profiles)";
			$queries[] = "DELETE FROM d_profiles_spells WHERE profile_id NOT IN (SELECT id FROM d_profiles)";

			$queries[] = "DELETE FROM parties WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM characters WHERE party_id NOT IN (SELECT id FROM parties)";
			$query = "SELECT id FROM characters WHERE char_type = 'char'";
			$ids = mod_Query2Array($query, false, 0);
			if (count($ids))
			{
				$queries[] = "DELETE FROM characters WHERE char_type != 'char' AND reference_char NOT IN (" . implode(',', $ids) . ')';
			}
			$queries[] = "DELETE FROM char_classes WHERE character_id NOT IN (SELECT id FROM characters)";
			$queries[] = "DELETE FROM char_domains WHERE character_id NOT IN (SELECT id FROM characters)";
			$queries[] = "DELETE FROM char_equipment WHERE character_id NOT IN (SELECT id FROM characters)";
			$queries[] = "DELETE FROM char_feats WHERE character_id NOT IN (SELECT id FROM characters)";
			$queries[] = "DELETE FROM char_forbidden WHERE character_id NOT IN (SELECT id FROM characters)";
			$queries[] = "DELETE FROM char_monsterattack WHERE character_id NOT IN (SELECT id FROM characters)";
			$queries[] = "DELETE FROM char_skills WHERE character_id NOT IN (SELECT id FROM characters)";
			$queries[] = "DELETE FROM char_spells WHERE class_id NOT IN (SELECT id FROM char_classes)";
			$queries[] = "DELETE FROM char_spellsknown WHERE class_id NOT IN (SELECT id FROM char_classes)";
			$queries[] = "DELETE FROM char_equipeffects WHERE equip_id NOT IN (SELECT id FROM char_equipment)";

			$queries[] = "DELETE FROM countries WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM towns WHERE country_id NOT IN (SELECT id FROM countries)";
			$queries[] = "DELETE FROM locations WHERE town_id NOT IN (SELECT id FROM towns)";

			$queries[] = "DELETE FROM images WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM items WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM item_list WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM money WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM money_rel WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM players WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM player_abbilities WHERE player_id NOT IN (SELECT id FROM players)";
			$queries[] = "DELETE FROM possession WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$queries[] = "DELETE FROM possession WHERE player_id != 0 AND player_id NOT IN (SELECT id FROM players)";
			$queries[] = "DELETE FROM possession WHERE item_id NOT IN (SELECT id FROM items)";
			$queries[] = "DELETE FROM story WHERE campaign_id NOT IN (SELECT id FROM campaigns)";
			$query = "SELECT id FROM story";
			$ids = mod_Query2Array($query, false, 0);
			if (count($ids))
			{
				$queries[] = "DELETE FROM story WHERE root != -1 AND root NOT IN (" . implode(',', $ids) . ')';
			}
			$queries[] = "DELETE FROM texts WHERE campaign_id NOT IN (SELECT id FROM items)";
			$queries[] = "DELETE FROM xp WHERE campaign_id NOT IN (SELECT id FROM items)";

			$del = 0;
			foreach ($queries as $query)
			{
				mod_mysql_querya($query);
				$del += mysql_affected_rows();
			}
			echo "Deleted Rows: $del";
		}
		else
		{
			echo "<a href='$modules_defaults[defaultlink]&docleanup=1'>Start Cleanup</a>";
		}
		break;

	case 'menuedit':
		$menuconfig = new menuconfig;
		$menuconfig->table = 'menu';
		$menuconfig->java = true;
		$menuconfig->rights = 'rights';
		if (mod_user_defaultcallback('root') === true) CreateMenuConfig($menuconfig);
		break;

	case 'restore':
		$restore = new restore;
		$restore->tables['players'] = array('Name' => 'name', 'Real Name' => 'real_name', 'add_sql' => 'campaigns.name AS Campaign');
		$restore->usertable = 'user';
		$restore->join = "LEFT JOIN campaigns ON campaigns.id = campaign_id";
		$restore->allowdelete = true;
		CreateRestore($restore);

		$restore->tables = array('campaigns' => array('Name' => 'name'));
		$restore->join = false;
		CreateRestore($restore);

		$restore->tables = array('datasets' => array('Name' => 'name'));
		CreateRestore($restore);
		break;

	case 'campaign':
		if (mod_user_defaultcallback('master') !== true) break;
		require 'campaign.php';
		break;

	case 'showlog':
		if (mod_user_defaultcallback('root') !== true) break;
		showlog($log);
		break;

	case 'showcounter':
		if (mod_user_defaultcallback('admin') !== true) break;
		ShowAccessList($log);
		break;

	case 'showstats':
		if (mod_user_defaultcallback('admin') !== true) break;
		$log->stats_user = true;
		ShowAccessStats($log);
		break;

	case 'showsessions':
		if (mod_user_defaultcallback('root') !== true) break;
		ShowSessions($user);
		break;

	case 'data':
		if (mod_user_defaultcallback('data') !== true) break;
		require 'data.php';
		break;

	default:
		require 'welcome.php';
		break;
}

mod_use_end();

echo <<<EOT

<html>
<head>
<title>($subindex) Jungbusch Campaign Management</title>
</head>

<style>

body
{
	padding-bottom:50;
}

</style>

$txt_pre

<body>

EOT;

if (isset($_GET['printview']))
{
	echo $txt_main;
}
else echo <<<EOT

<table width=100% cellpadding=5>
<tr><td valign=top width=150>$txt_menu<br><hr width=80% align=left><br>$txt_login<hr>Counter: $globaldata[counter]</td>
<td valign=top>$txt_main</td></tr>
</table>

<br><br><br><br><br><br>

EOT;

echo <<<EOT

</body>

</html>

EOT;

?>
