
<?php

require_once 'mod_functions.php';

$mod_dwMenuInstance = 0;
$mod_dwMenuConfigInstance = 0;

class menu
{
	public $sql;				//SQL Connection
	public $table;				//SQL Table Name
	public $defaultlink = false;		//Default Parameters included in every link
	public $target_id = false;		//User Defined target Menu Entry
	public $html = false;			//Array with HTML Strings, Start of Line, After depth indent, End of line, if set to a string only it represents end of line. If an array is given instead of a string it can contain 3 string representing colors etc for current menu selection ("[ID]" will be replaced with the entry id)
	public $pre_function = false;		//String with the name of a callback function that is called with the depth of the current menu tree as parameter and returns a prestring, if set a numeric value that many spaces are used
	public $callback_func = false;		//String with the name of a callback function that is called with the misc parameterand the id as second parameter for each menu entry and returns true/false to display the menu entry or not
	public $nolinks = false;		//Set true if you dont want links in the menu (just display it...)
	public $permissiondenied = false;	//Set to true to die if $_SERVER['PHP_SELF'] is listet in menu db but not allowed for user or set a string to call a callback function then. You should somehow be careful with this, for example if you include files or so, better do a seperate check for important rights
	public $javamenu = false;		//Use Java-Script to open menu where no new page is loaded (You must add a [JAVA] in the html tags. The object that contains [JAVA] will be set display:none to hide)
	public $javasql = false;		//Set true if you have a java col in sql db. Values are: -1: always reload, 0: default, 1: never reload, give string for an sql query to determine where [ID] will be replaced
	public $checkrights = false;		//Set true to check if $userdata['rights'] has enough rights to display the entry. Can also give an integer that is compared with required rights. Set to a negative value for comparison (rights == -checkrights), string for sql where
	public $loginright = true;		//Right to display menu if logged in (-100)
	public $preurlopt = '';			//String that precedes urlopt parameter from db
	public $multilanguage = false;		//Table Name with entries for other languages (2 letter code only)
	public $language = false;		//Language for Multi Language Mode, false or '' for standard Menu Name
	public $prenames = false;		//Write rootnames in front of names, give a string for seperator
	
	public $addlink = '';			//Return value to add to defaultlink
	public $url = true;			//URL Field in SQL db (Leave on for real menu!!)

	public $submenu_count = 0;		//Max Amount of Splits in the menu
}

function mod_Menu_GetRootIDs($menu, $id = false)
{
	global $mod_txt;
	if ($id === false)
	{
		$curid = intval($menu->target_id);
	}
	else
	{
		$curid = intval($id);
	}
	$ids = array($curid);

	while ($curid != -1)
	{
		$query = "SELECT root FROM " . $menu->table . " WHERE id = $curid";
		$result = mod_mysql_querya($query, $menu->sql);
		if (mysql_num_rows($result) == 0)
		{
			trigger_error($mod_txt['menu_internal_error'], E_USER_ERROR);
		}
		$curid = $ids[] = mysql_result($result, 0);
		mysql_free_result($result);
	}
	return(array_reverse($ids));
}

function mod_Menu_GetSubIDs($menu, $id, $recurse = true)
{
	$esTable = mysql_escape_string($menu->table);
	$query = "SELECT id FROM `$esTable` WHERE root = $id";
	$result = mod_mysql_querya($query, $menu->sql);
	$retVal = array($id);
	while ($tmp = mysql_fetch_assoc($result))
	{
		$retVal[] = $tmp['id'];
		if ($recurse)
		{
			$retVal = array_merge($retVal, mod_Menu_GetSubIDs($menu, $tmp['id'], true));
		}
	}
	mysql_free_result($result);
	return($retVal);
}

function CreateMenu(&$menu_data, $root = -1, $pre = 0, $ids = false, $retout = false, $child = false, $openids = false, $checkTable = true, $prenames = '')
{
	global $mod_dwMenuInstance, $userdata, $mod_txt, $modules_defaults, $modules_config;

	$out = '';

	$esTable = mysql_escape_string($menu_data->table);

	if ($child === false)
	{
		mod_doDefaults($menu_data, 'modules_defaults', false, false);

		if (isset($modules_defaults) && isset($modules_defaults['user_data_config']) && isset($userdata['data']['mod_config']['java_menu']))
		{
			$menu_data->javamenu = $userdata['data']['mod_config']['java_menu'];
		}
		if (isset($modules_config['template']) && isset($modules_config['template']['menu_html'])) $menu_data->html = $modules_config['template']['menu_html'];
		if (isset($modules_config['template']) && isset($modules_config['template']['menu_submenucount'])) $menu_data->submenu_count = $modules_config['template']['menu_submenucount'];

		if ($menu_data->table === false) trigger_error('No Table Name given!', E_USER_ERROR);
		if ($checkTable) checkTable('menu', $menu_data->table, $menu_data->sql);

		if ($menu_data->html === false)
		{
			if ($menu_data->javamenu)
			{
				$menu_data->html = array('<div [JAVA]>', '', '</div>');
			}
			else
			{
				$menu_data->html = array('', '', '<br>');
			}
		}

		if ($menu_data->target_id === false)
		{
			if (isset($_REQUEST["mod_setmenu$mod_dwMenuInstance"]))
			{
				$menu_data->target_id = intval($_REQUEST["mod_setmenu$mod_dwMenuInstance"]);
			}
			else
			{
				$menu_data->target_id = -1;
			}
		}
		$menu_data->addlink .= "&mod_setmenu$mod_dwMenuInstance=$menu_data->target_id";

		if ($ids === false)
		{
			if ($openids === false)
			{
				$openids = mod_Menu_GetRootIDs($menu_data);
			}

			if ($menu_data->javamenu)
			{
				$ids = mod_Menu_GetSubIDs($menu_data, $root);
				$out .= "<script>mod_menu_ids[$mod_dwMenuInstance] = [" . implode(',', mod_Menu_GetRootIDs($menu_data)) . '];</script>';

				$query = "SELECT id, root FROM `$esTable`";
				$result = mysql_query($query, $menu_data->sql);
				$out .= "<script>\nmod_menu_rootid[$mod_dwMenuInstance] = $root;\nmod_menu_root[$mod_dwMenuInstance] = [];\n";
				while($tmp = mysql_fetch_assoc($result))
				{
					$out .= "mod_menu_root[$mod_dwMenuInstance][$tmp[id]] = $tmp[root];\n";
				}
				$out .= "\n</script>";
				mysql_free_result($result);
			}
			else
			{
				$ids = $openids;
			}
		}
		$menu_data->defaultlink = substr($menu_data->defaultlink, strpos($menu_data->defaultlink, '?'));
		$menu_data->defaultlink = mod_removeURLParam($menu_data->defaultlink, "mod_setmenu$mod_dwMenuInstance");

		if ($menu_data->permissiondenied !== false)
		{
			$query = "SELECT urlopt, misc FROM `$esTable` WHERE url = '" . mysql_escape_string(basename($_SERVER['PHP_SELF'])) . "'";
			$result = mod_mysql_querya($query, $menu_data->sql);
			while ($tmp = mysql_fetch_assoc($result))
			{
				$tmp['urlopt'] = explode('&', $menu_data->preurlopt . $tmp['urlopt']);
				foreach ($tmp['urlopt'] as $opt)
				{
					if ($opt == '') continue;
					$opt = explode('=', $opt);
					$ofound = 1;
					foreach ($opt as $oname => $oval)
					{
						if (!isset($_REUQEST[$oname]) || $_REQUEST[$oname] != $oval)
						{
							$ofound = 0;
							break;
						}
					}
					if ($ofound) break;
				}
				if ((!isset($ofound) || (isset($ofound) && $ofound)) && mod_user_defaultcallback($tmp['misc']) == false)
				{
					if ($menu_data->permissiondenied === true)
					{
						die($mod_txt['menu_permission_denied']);
					}
					else
					{
						call_user_func($menu_data->permissiondenied);
					}
				}
			}
		}
	}

	for ($i = 0;$i < count($menu_data->html);$i++)
	{
		if (!is_array($menu_data->html[$i]))
		{
			$menu_data->html[$i] = array($menu_data->html[$i], $menu_data->html[$i], $menu_data->html[$i]);
		}
		for ($j = count($menu_data->html[$i]);$j < 3;$j++)
		{
			$menu_data->html[$i][$j] = $menu_data->html[$i][0];
		}
	}

	if ($menu_data->target_id != -1 && $menu_data->url)
	{
		$query = "SELECT url, urlopt FROM `$esTable` WHERE id = " . intval($menu_data->target_id);
		$target_data = mysql_fetch_assoc(mod_mysql_querya($query, $menu_data->sql));
	}

	if ($menu_data->checkrights !== false)
	{
		if ($menu_data->checkrights === true)
		{
			$rightpart = "(misc & $userdata[rights]) = misc";
			if ($menu_data->loginright) $rightpart .= ($userdata['id'] ? ' OR misc = -100' : ' AND misc != -100');
		}
		else if (is_string($menu_data->checkrights))
		{
			$rightpart = "$menu_data->checkrights";
		}
		else if ($menu_data->checkrights < 0)
		{
			$rightpart = 'misc = ' . intval(-$menu_data->checkrights);
		}
		else
		{
			$rightpart = '(misc & ' . intval($menu_data->checkrights) . ') = misc';
		}
		$rightpart = "AND ($rightpart)";
	}
	else
	{
		$rightpart = '';
	}

	if ($menu_data->multilanguage !== false && $menu_data->language !== false && strlen($menu_data->language) && $menu_data->language != 'en')
	{
		checkTable('menulang', $menu_data->multilanguage);

		$esMultiLan = mysql_escape_string($menu_data->multilanguage);
		$esLan = mysql_escape_string($menu_data->language);
		$joinpart = "LEFT JOIN `$esMultiLan` ON `$esTable`.id = `$esMultiLan`.menu_id AND language = '$esLan'";
		$usename = "IFNULL(`$esMultiLan`.name, `$esTable`.name)";
	}
	else
	{
		$joinpart = '';
		$usename = "`$esTable`.name";
	}

	$tmpouts = array();
	$query = "SELECT `$esTable`.*, $usename AS usename FROM `$esTable` $joinpart WHERE root = $root $rightpart ORDER BY sort ASC";
	$result = mod_mysql_querya($query, $menu_data->sql);
	while ($tmp = mysql_fetch_assoc($result))
	{
		if ($menu_data->callback_func !== false && call_user_func($menu_data->callback_func, isset($tmp['misc']) ? $tmp['misc'] : $tmp['id'], $tmp['id']) === false) continue;
		$query = "SELECT COUNT(*) FROM `$esTable` WHERE root = $tmp[id]";
		$htmlid = intval(($menu_data->javamenu ? in_array($tmp['id'], $openids) : in_array($tmp['id'], $ids)) || $tmp['id'] == $menu_data->target_id);
		if ($htmlid && ($subcount = mysql_result(mod_mysql_querya($query, $menu_data->sql), 0)) == 0) $htmlid++;

		$tmpout = str_ireplace('[ID]', $tmp['id'], $menu_data->html[0][$htmlid]);

		if ($tmp['name'] !== '-')
		{
			if ($menu_data->pre_function === false || is_numeric($menu_data->pre_function))
			{
				$tmpout .= '<font>';
				for ($i = 0;$i < $pre * ($menu_data->pre_function === false ? 2 : $menu_data->pre_function);$i++)
				{
					$tmpout .= '&nbsp;';
				}
				$tmpout .= '</font>';
			}
			else
			{
				$tmpout = call_user_func($menu_data->pre_function, $pre);
			}
			$tmpout .= str_ireplace('[ID]', $tmp['id'], $menu_data->html[1][$htmlid]);

			if ($menu_data->javamenu)
			{
				if ((isset($subcount) && $subcount == 0) || ($subcount = mysql_result(mod_mysql_querya($query, $menu_data->sql), 0)) == 0)
				{
					$hit = 0;
				}
				else if ($menu_data->javasql !== false && (is_string($menu_data->javasql) || $tmp['java']))
				{
					if ($tmp['java'] == 0 && is_string($menu_data->javasql))
					{
						$hit = (mysql_result(mod_mysql_querya(str_replace('[ID]', $tmp['id'], $menu_data->javasql), $menu_data->sql), 0) > 0);
					}
					else
					{
						$hit = ($tmp['java'] == 1);
					}
				}
				else if (isset($target_data))
				{
					$hit = ($tmp['url'] == $target_data['url'] && $tmp['urlopt'] == $target_data['urlopt']);
					
				}
				else
				{
					$hit = ($tmp['urlopt'] == '' && ($tmppos = stripos($_SERVER['PHP_SELF'], $tmp['url'])) !== false && $tmppos + strlen($tmp['url']) == strlen($_SERVER['PHP_SELF']));
				}
				unset($subcount);
				if ($hit)
				{
					$tmpout .= "<a href='JavaScript:mod_ChangeMenu($mod_dwMenuInstance, $tmp[id]);'>";
				}
			}

			if (!$menu_data->javamenu || $hit == false)
			{
				if ($menu_data->nolinks === false) $tmpout .= "<a href='$tmp[url]$menu_data->defaultlink&mod_setmenu$mod_dwMenuInstance=" .
					$tmp[in_array($tmp['id'], $openids) && count(mod_Menu_GetSubIDs($menu_data, $tmp['id'], false)) > 1 ? 'root' : 'id'] .
					"$menu_data->preurlopt$tmp[urlopt]'>";
			}
			$tmpout .= $prenames . $tmp['usename'];
			if ($menu_data->nolinks === false) $tmpout .= '</a>';
		}
		else
		{
			$tmpout .= '&nbsp;';
		}
		$tmpout .= str_ireplace('[ID]', $tmp['id'], $menu_data->html[2][$htmlid]) . "\n";
		if ($menu_data->javamenu)
		{
			$tmpout = str_ireplace('[JAVA]', "id='mod_menutable$mod_dwMenuInstance-$tmp[id]' ", $tmpout);

		}

		if ($retout === -1)
		{
			$tmpouts[$tmp['id']] = $tmpout;
		}
		else if ((($retout === -2 && $tmp['name'] !== '-') || $menu_data->submenu_count == 0) && count($tmpouts))
		{
			$tmpouts[count($tmpouts) - 1] .= $tmpout;
		}
		else
		{
			if ($retout == -2 && $menu_data->submenu_count > 0)
			{
				if (isset($remfirst))
				{
					$tmpout = '';
				}
				else
				{
					$remfirst = true;
				}
			}
			$tmpouts[] = $tmpout;
			if ($menu_data->submenu_count) $menu_data->submenu_count--;
		}
		if (in_array($tmp['id'], $ids) && $tmp['name'] !== '-')
		{
			$tmpmenu = CreateMenu($menu_data, $tmp['id'], $pre + 1, $ids, $retout === -1 ? -1 : true, true, $openids, true, $menu_data->prenames !== false ? "$prenames$tmp[usename]$menu_data->prenames" : '');
			if ($retout === -2)
			{
				$tmpouts[count($tmpouts) - 1] .= $tmpmenu;
			}
			else if ($retout === -1)
			{
				$tmpouts += $tmpmenu;
			}
			else
			{
				$tmpouts[] = $tmpmenu;
			}
		}
	}

	if ($retout === -1 || $retout === -2)
	{
		if (count($tmpouts))
		{
			$tmpkey = mod_ae2(array_keys($tmpouts), 0);
			$tmpouts[$tmpkey] = $out . $tmpouts[$tmpkey];
		}
		else if ($out != '')
		{
			$tmpouts[0] = $out;
		}
	}
	else
	{
		$out .= implode('',$tmpouts);
	}

	mysql_free_result($result);
	
	if (!$child)
	{
		if ($menu_data->javamenu)
		{
			if ($retout === -1 || $retout === -2)
			{
				$tmpouts[count($tmpouts) - 1] .= "<script>mod_UpdateMenu($mod_dwMenuInstance);</script>";
			}
			else
			{
				$out .= "<script>mod_UpdateMenu($mod_dwMenuInstance);</script>";
			}
		}
		$mod_dwMenuInstance++;
	}

	if ($retout === -1 || $retout === -2)
	{
		return($tmpouts);
	}
	else if ($retout)
	{
		return($out);
	}
	else
	{
		echo $out;
	}
}

class menuconfig
{
	public $sql;			//SQL Connection
	public $table;			//SQL Table Name
	public $defaultlink = false;	//Default Parameters for each link
	public $noupdate = false;	//Set true to forbit any changes
	public $title = false;		//Edit Table Caption
	public $rights = false;		//Point to a right db (see user module)
	public $loginright = true;	//Right to display menu if logged in
	public $java = false;		//Set true if a col for Java Menu Rules exists, set to -1, 0, 1 to define default value
	public $url = true;		//URL Field (required for real menu :|)
	public $forceparam = false;	//Set to an integer to force misc field to this value!
	public $multilanguage = false;	//Table Name with entries for other languages (2 letter code only)
	public $editdata = array();	//Sqledit data
	public $edit_callback = false;	//Callback function that is passed $edit object by reference beforte creating
	public $rootname = 'Menu';	//Root Name
	public $entryname = false;	//Entry name

	public $editrights = array();	//Rights required to do real edit, names can be edited though without
	public $protectuser = false;	//Same as mod_user
}

function mod_CreateMenuConfig_B($misc, $id)
{
	global $mod_CreateMenuConfig_Bval;
	$retVal = !in_array($id, $mod_CreateMenuConfig_Bval);
	return($retVal);
}

function mod_CreateMenuConfig_A($val, $id, $name)
{
	global $mod_CreateMenuConfig_Aval, $mod_CreateMenuConfig_Bval, $mod_txt;
	$menu = new menu;
	$menu->sql = $mod_CreateMenuConfig_Aval->sql;
	$menu->table = $mod_CreateMenuConfig_Aval->table;
	$menu->html = array('<option value=[ID]>', '', '</option>');
	$menu->callback_func = 'mod_CreateMenuConfig_B';
	$menu->nolinks = true;
	$menu->url = $mod_CreateMenuConfig_Aval->url;
	if ($mod_CreateMenuConfig_Aval->forceparam !== false)
	{
		$menu->checkrights = -$mod_CreateMenuConfig_Aval->forceparam;
	}

	$esTable = mysql_escape_string($mod_CreateMenuConfig_Aval->table);

	$query = "SELECT id FROM $esTable";
	$ids = mod_Query2Array($query, $mod_CreateMenuConfig_Aval->sql, 0);
	$mod_CreateMenuConfig_Bval = mod_Menu_GetSubIDs($menu, $id);

	$retVal = "<select name='$name'><option value=-1>" . ($mod_CreateMenuConfig_Aval->rootname == 'Menu' ? $mod_txt['menu_config_main_menu'] : $mod_CreateMenuConfig_Aval->rootname) . "</option>";
	$retVal .=  CreateMenu($menu, -1, 1, $ids, true, true);
	$retVal .= '</select>';

	$retVal = str_replace("<option value=$val>", "<option value=$val selected>", $retVal);

	return($retVal);
}

function mod_CreateMenuConfig_C($id)
{
	global $mod_CreateMenuConfig_Cval;

	$esTable = mysql_escape_string($mod_CreateMenuConfig_Cval->table);

	$query = "SELECT id FROM `$esTable` WHERE root = $id";
	$result = mod_mysql_querya($query, $mod_CreateMenuConfig_Cval->sql);
	while ($tmp = mysql_fetch_assoc($result))
	{
		mod_CreateMenuConfig_C($tmp['id']);
	}
	mysql_free_result($result);
	$query = "DELETE FROM `$esTable` WHERE root = $id";
	mod_mysql_querya($query, $mod_CreateMenuConfig_Cval->sql);
}

function CreateMenuConfig($menu_data)
{
	global $mod_dwMenuConfigInstance, $mod_txt;
	global $mod_CreateMenuConfig_Aval, $mod_CreateMenuConfig_Cval;
	global $mod_CreateRightEdit_Callbackval, $modules_rights, $userdata;

	mod_doDefaults($menu_data);

	if ($menu_data->table === false) trigger_error('No Table Name given', E_USER_ERROR);

	checkTable('menu', $menu_data->table, $menu_data->sql);

	$esTable = $menu_data->table;

	$menu_data->defaultlink = mod_removeURLParam($menu_data->defaultlink, "mod_menuconfig$mod_dwMenuConfigInstance");

	if (isset($_REQUEST["mod_menuconfig$mod_dwMenuConfigInstance"]))
	{
		$config_root = intval($_REQUEST["mod_menuconfig$mod_dwMenuConfigInstance"]);
	}
	else
	{
		$config_root = -1;
	}
	$menu_data->defaultlink .= "&mod_menuconfig$mod_dwMenuConfigInstance=$config_root";

	$edit = new sqledit;
	$edit->sql = $menu_data->sql;
	$edit->defaultlink = $menu_data->defaultlink;
	$edit->sqltablename = $menu_data->table;
	if ($menu_data->entryname !== false) $edit->name = $menu_data->entryname;
	if ($menu_data->title === false)
	{
		$edit->title = sprintf($mod_txt['menu_config_edit'], $menu_data->table);
	}
	else
	{
		$edit->title = $menu_data->title;
	}
	if ($config_root != -1)
	{
		$ids = mod_Menu_GetRootIds($menu_data, $config_root);
		for ($i = 0;$i < count($ids);$i++)
		{
			$tmp = '';
			for ($j = 0;$j < $i;$j++) $tmp .= '&nbsp;&nbsp;';
			$query = "SELECT name FROM `$esTable` WHERE ID = $ids[$i]";
			$edit->prelines[] = array('Name' => $tmp . ($ids[$i] == $config_root ? '<b>' . mysql_result(mod_mysql_querya($query, $menu_data->sql), 0) . '</b>' : "<a href='" . mod_linkAddParameter($menu_data->defaultlink, "mod_menuconfig$mod_dwMenuConfigInstance", $ids[$i]) . "#mod_menuconf$mod_dwMenuConfigInstance" . "'>" . ($ids[$i] == -1 ? $menu_data->rootname : mysql_result(mod_mysql_querya($query, $menu_data->sql), 0)) . '</a><br>'));
		}
		$query = "SELECT name FROM `$esTable` WHERE id = $config_root";
		$edit->title .= ' (' . mysql_result(mod_mysql_querya($query, $menu_data->sql), 0) . ')';
		$edit->prelines[] = array($mod_txt['menu_config_name'] => '<hr>', $mod_txt['menu_config_url'] => '<hr>', $mod_txt['menu_config_url_param'] => '<hr>', $mod_txt['edit_functions'] => '<hr>');
	}

	if (!isset($tmp)) $tmp = '';
	$tmp = '&nbsp;&nbsp;';

	$edit->relations = array(
				'name' => array('force' => true, 'sql' => "CONCAT('$tmp', `$esTable`.name)", 'name' => $mod_txt['menu_config_name'], 'link' => mod_linkAddParameter($menu_data->defaultlink, "mod_menuconfig$mod_dwMenuConfigInstance", '[ID]') . "#mod_menuconf$mod_dwMenuConfigInstance"),
				'root' => array('name' => $mod_txt['menu_config_root'], 'hide' => true, 'default' => $config_root,
					'type' => 'callback', 'func' => 'mod_CreateMenuConfig_A')
			);
	if ($menu_data->url)
	{
		$edit->relations['url'] = array('name' => $mod_txt['menu_config_url']);
		$edit->relations['urlopt'] = array('name' => $mod_txt['menu_config_url_param']);
	}
	if (is_bool($menu_data->rights))
	{
		if ($menu_data->forceparam !== false)
		{
			$edit->adddefaults['misc'] = $menu_data->forceparam;
			$edit->relations['root']['force'] = "(SELECT -1 AS id) UNION (SELECT id FROM `$esTable` WHERE misc = $menu_data->forceparam)";
		}
		else
		{
			$edit->relations['misc'] = array('name' => ($menu_data->rights ? $mod_txt['menu_config_admin'] : $mod_txt['menu_config_param']));
			if ($config_root != -1)
			{
				$edit->prelines[($menu_data->rights ? $mod_txt['menu_config_admin'] : $mod_txt['menu_config_param'])] = '<hr';
			}
		}
	}
	else
	{
		$mod_CreateRightEdit_Callbackval = $menu_data;
		$edit->relations['misc'] = array('name' => $mod_txt['menu_config_rights'], 'type' => 'callback', 'func' => 'CreateRightEdit_callback');
	}

	if ($menu_data->java !== false)
	{
		$edit->relations['java'] = array('name' => $mod_txt['menu_config_java'], 'type' => 'select', 'options' => array(-1 => $mod_txt['menu_config_java_always'], 0 => $mod_txt['menu_config_java_default'], 1 => $mod_txt['menu_config_java_never']));
		if ($menu_data->java !== true) $edit->relations['java']['default'] = $menu_data->java;
	}

	if ($menu_data->multilanguage)
	{
		checkTable('menulang', $menu_data->multilanguage);
		$edit->relations['name']['formname'] = $edit->relations['name']['name'] . ' (en)';
		$edit->relations['languages'] = array('name' => $mod_txt['menu_config_languages'], 'type' => 'multi', 'hide' => true, 'sqllink' => $menu_data->multilanguage,
			'sqllinkdata' => array('menu_id' => '[ID]', 'language' => '[LINK0]', 'name' => '[LINK1]'),
			'multilink' => true, 'multitexthtml' => 'Language:&nbsp;<input type=text name="[NAME][0]" size=2>&nbsp;Menu:&nbsp;<input type=text name="[NAME][1]">');
	}

	$edit->sqlwhere = "`" . mysql_escape_string($menu_data->table) . "`.root = $config_root";
	if ($menu_data->forceparam !== false)
	{
		$edit->sqlwhere .= " AND `" . mysql_escape_string($menu_data->table) . "`.misc = $menu_data->forceparam";
	}
	$edit->deletecallback = 'mod_CreateMenuConfig_C';

	mod_doDefaults($edit, $menu_data->editdata, true);
	if ($menu_data->edit_callback !== false)
	{
		$tmp = $menu_data->edit_callback;
		$tmp($edit);
	}

	if (count($menu_data->editrights) && mod_user_defaultcallback($menu_data->editrights) !== true)
	{
		$tmp_rights = 0;
		$edit->relations['url']['editable'] = $edit->relations['urlopt']['editable'] = false;
		$edit->sqlforcewhere = "(misc & $userdata[rights]) = misc";
		$edit->addable = $edit->deleteable = false;
		$menu_data->protectuser = $menu_data->editrights;
	}
	if ($menu_data->protectuser !== false) $menu_data->protectuser = mod_collapseRightId($menu_data->protectuser);

	$mod_CreateMenuConfig_Aval = $mod_CreateMenuConfig_Cval = $menu_data;

	echo "<a name='mod_menuconf$mod_dwMenuConfigInstance'></a>";
	CreateSqlEdit($edit);
	unset($edit);

	$mod_dwMenuConfigInstance++;
}

function CreateSubMenu($menu, $rootname, $line = false)
{
	$query = "SELECT id FROM `" . mysql_escape_string($menu->table) . "` WHERE name = '" . mysql_escape_string($rootname) . "'";
	$result = mod_mysql_querya($query, $menu->sql);
	if (mysql_num_rows($result) == 1)
	{
		if ($line)
		{
			$menu->html = array(' - ', '', '');
		}
		CreateMenu($menu, mysql_result($result, 0));
		if ($line) echo ' -';
	}
}

function mod_getMenuName($menu, $id = false)
{
	if ($id === false) $id = $menu->target_id;

	$esTable = mysql_escape_string($menu->table);

	if ($menu->multilanguage !== false)
	{
		$esMulti = mysql_escape_string($menu->multilanguage);
		$esLanguage = mysql_escape_string($menu->language);
		$select = "IFNULL(`$esMulti`.name, `$esTable`.name)";
		$join = "LEFT JOIN `$esMulti` ON `$esMulti`.menu_id = `$esTable`.id AND `$esMulti`.language = '$esLanguage'";
	}
	else
	{
		$select = "`$esTable`.name";
		$join = '';
	}
	$id = intval($id);

	$query = "SELECT $select FROM `$esTable` $join WHERE `$esTable`.id = $id";
	$result = mod_mysql_querya($query, $menu->sql);
	return(mysql_num_rows($result) ? mysql_result($result, 0) : '');
}

?>