<?php

//Exportet Global Vars:
//$user, $menu, $menuconfig, $log, $userdata, $session, $log, $template, $modules_defaults, $sql, $txt_pre, $txt_login, $txt_menu, $txt_main

if (isset($_REQUEST['mod_use_galview']) && $_REQUEST['mod_use_galview'])
{
	$mod_use['useset'] = 'image';
}

require_once 'mod_functions.php';

$mod_use_sets = array(
	'qon' => array(
		'adminrights' => array('root', 'admin'),
		'protectadminrights' => array('root'),
		'protectadminuser' => array('root'),
		'protectuser' => 'root',
		'limitadmin' => 'root',
		'menueditrights' => 'root',
		'menupreurl' => '&setindex=',
		'usertimeout' => 45 * 60,
		'useralias' => 'root'
	),
	'image' => array(
		'menu' => false,
		'log' => false,
		'charsetheader' => false,
		'nolayout' => true,
		'redir_changes' => false
	)
);

class mod_use
{
	public $error_reporting = E_ALL;			//Error reporting Value
	public $dieonerror = true;				//Always abort when an error occured, set to 1 but not true if you dont want an message to be displayed, set to a string for a custom message

	public $redir_changes = true;				//Reload Page after Change to db
	public $askdelete = true;				//Askdelete (mod_sqledit.php)

	public $sql = array('localhost', 'root', '', '');	//SQL Connection (server, user, pw, db)
	public $checkdb = true;					//Check if SQL Database conforms with standards in mod_db.php
	public $exportsql = true;				//Export Connection to $sql var

	public $locale = 'de_DE';				//Locale
	public $language = 'en';				//Language, set to true to take language from autoindex 'lang'!;
	public $defaultlanguage = 'de';				//Default language if 'lang' is not set
	public $timezone = 'Europe/Amsterdam';			//Timezone (false for none)
	public $charset = 'latin1';				//Default Charset
	public $charsetheader = true;				//Export Charset as HTTP Header

	public $magic_unquote = true;				//Magic Unquote GET/POST Vars
	public $autoindexes = array();				//Automaticly create defaultlink and add indexes ('name' => 'default val'), empty error for disabling. Can provide an array as defalt value array('callback func', 'default')
	public $foldindexes = array();				//Supply an array with varnames that point to an array of values to fold for that var and not add to defaultlink
	public $userautoindexes = array(array(), array());	//Array with additional autoindexes login dependent userid = 0 --> first, else secondd
	public $autojava = true;				//Execute AutoJavaTable, will also autocreate defaultlink
	public $javaavailable = true;				//Will be autoset to false if autojava returns false
	public $changelink = true;				//Add sth. to defaultllink, that changes the link with every page.

	public $user = 'user';					//User Table
	public $userrelations = array();			//User Relations to pass to user class
	public $userdata = 1;					//Userdata (mod_user.php), 1 to copy globaldata
	public $userdataconfig = true;				//Exports $modules_defaults[user_data_config] // Will allow user to autoconfig using $userdata[data][mod_config] some stuff (CreateUserConfig...) and is autoread by menu/forum/etfc
	public $alwayssession = true;				//Always Create Session
	public $sessiondata = true;				//Provide $session functionality
	public $session = 'session';				//Session Table
	public $usersavedelete = true;				//Dont delete users just disable
	public $rights = 'rights';				//Rights Table
	public $groups = false;					//Group Table
	public $grouplinktable = 'group_link';			//Name of Group Link table for groups
	public $usertimeout = false;				//User Timeout
	public $userdefaultdata = array();			//Default datas that will be pasted with doDefaults (forced) to the apropriate module
	public $adminrights = array();				//mod_user->adminrightrs
	public $protectuser = false;				//
	public $limitadmin = false;				//
	public $protectadminrights = array();			//mod_user->protectadminrights
	public $protectadminuser = array();			//mod_use->adminuser
	public $useralias = false;				//
	public $ssllogin = false;				//See mod_user.php

	public $menu = 'menu';					//Menu Table
	public $menuhtml = false;				//Menu HTML Code (see menu file), false for default
	public $menulan = false;				//Menu Multi Language Table
	public $menupreurl = '';				//Menu Pre URL
	public $menupermissiondenied = true;			//Menu Option
	public $javamenu = true;				//Java Menu, passed to configmenu as java
	public $menudefaultdata = array();			//
	public $menuconfigdefaultdata = array();		//
	public $menueditrights = false;				//

	public $autosetup = false;				//If set to true, rightsedit will be displayed, if adminrights dont exist, if no user with adminrights exists, useredit will be displayed, menuconfig will be displayed if menu db is empty

	public $log = 'log';					//Log Table (false for no log)
	public $logparam = 'log_param';				//Log Parameter Table
	public $logdefaultdata = array();			//
	public $log_param_name = false;				//Name of callback function, if not callable Var name in $_REQUEST where log.param is stored

	public $globaldata = 'globals';				//Globaldata (mod_user.php)
	public $counter = true;					//Counter (mod_user.php)

	public $useset = false;					//Import from mod_use_sets
	public $nolayout = false;				//1 for $nocss, true for $nolayout
	public $domsg = true;					//Convert mod_msg to txt_msg

	public $action_table = 'action';			//modules_defaults[action_table]
	public $action_defaults = true;				//modules_defaults[action_defaults], true for defaults
	public $changes_table = 'changes';			//modules_defaults[changes_table]
	public $changes_defaults = true;			//mod_std type to log changes, true for defaults

	public $template = false;				//String for tablename, true for array only
	public $templatedata = array();				//Default Data again...

	public $shop = false;					//Webshop?
}

function mod_dieOnErrorHandler($errno, $errstr, $errfile, $errline)
{
	global $mod_use;
	if ($mod_use->dieonerror === true)
	{
		if (ob_get_level()) echo ob_get_clean();

		$errText = "PHP Error [$errno] $errstr\n\rError in line $errline of file $errfile\n\r\n\r";
		echo $errText;
	}
	else if (is_string($mod_use->dieonerror));
	{
		echo $mod_use->dieonerror;
	}
	die();
}

function mod_use_init()
{
	global $mod_use, $modules_defaults, $mod_use_sets, $mod_nolayout, $mod_nocss;

	if (!isset($mod_use)) return;

	$tmp = new mod_use;
	if (isset($mod_use['useset']) && $mod_use['useset'] !== false) mod_doDefaults($tmp, $mod_use_sets[$mod_use['useset']], true);
	mod_doDefaults($tmp, 'mod_use', true);
	$mod_use = $tmp;

	error_reporting($mod_use->error_reporting);
	if ($mod_use->dieonerror !== false) set_error_handler('mod_dieOnErrorHandler');

	if ($mod_use->nolayout === true) {$mod_nolayout = true;}
	else if ($mod_use->nolayout === 1) $mod_nocss = true;

	$modules_defaults['mod_redir_changes'] = $mod_use->redir_changes;
	$modules_defaults['magic_unquote'] = $mod_use->magic_unquote;
	if (is_string($mod_use->language))
	{
		$modules_defaults['language'] = $mod_use->language;
	}
	$modules_defaults['charset'] = $mod_use->charset;
	$modules_defaults['askdelete'] = $mod_use->askdelete;

	if ($mod_use->action_table !== false) $modules_defaults['action_table'] = $mod_use->action_table;
	if ($mod_use->action_defaults === true) $mod_use->action_defaults = array(
		'user_login' => array('count' => 3, 'time' => 60),
		'gbook' => array('count' => 2, 'time' => 120),
		'comments' => array('count' => 2, 'time' => 60),
		'forum' => array('count' => 5, 'time' => '60')
	);
	if ($mod_use->action_defaults !== false) $modules_defaults['action_defaults'] = $mod_use->action_defaults;
	if ($mod_use->changes_table !== false) $modules_defaults['changes_table'] = $mod_use->changes_table;
	if ($mod_use->changes_defaults === true) $mod_use->changes_defaults = array('news' => 'text', 'comments' => 'text', 'gbook' => 'text', 'forum' => 'text');
	if ($mod_use->changes_defaults !== false) $modules_defaults['changes_defaults'] = $mod_use->changes_defaults;

	if ($mod_use->timezone !== false) date_default_timezone_set($mod_use->timezone);

	if ($mod_use->locale !== false)
	{
		setlocale(LC_TIME, $mod_use->locale);
	}

	$modules_defaults['checkdb'] = $mod_use->checkdb;

	if ($mod_use->userdataconfig) $modules_defaults['user_data_config'] = true;
}

function mod_do_autoindexes($indexes)
{
	global $mod_use, $modules_defaults;
	foreach ($indexes as $index => $val)
	{
		if (is_array($val))
		{
			mod_autoindex($index, call_user_func($val[0], mod_autoindex($index, isset($val[1]) ? $val[1] : false, false, false, true)), 'addslashes', true, -1);
		}
		else
		{
			mod_autoindex($index, $val, 'addslashes');
		}
		if (isset($_REQUEST[$index]))
		{
			if (isset($mod_use->foldindexes[$index]) && in_array($_REQUEST[$index], $mod_use->foldindexes[$index]))
			{
				$modules_defaults['defaultlink'] .= "&$index=$val";
			}
			else
			{
				$modules_defaults['defaultlink'] .= "&$index=" . $_REQUEST[$index];
			}
		}
	}
}

function mod_use_go()
{
	global $userdata, $log, $user, $menu, $menuconfig, $mod_use, $modules_defaults, $txt_pre, $txt_login, $txt_menu, $sql, $template, $mod_txt, $mod_dwMenuInstance;

	if (!isset($mod_use)) return;
	if ($mod_use->redir_changes && ob_get_level() == 0)
	{
		trigger_error('Output Buffering not enabled', E_USER_ERROR);
	}

	$txt_pre = ob_get_contents();
	ob_clean();

	if ($mod_use->language === true)
	{
		mod_SetLanguage($mod_use->language = $modules_defaults['language'] = (isset($_REQUEST['lang']) ? $_REQUEST['lang'] : $mod_use->defaultlanguage), true);
	}

	if ($mod_use->sql[3] == '')
	{
		trigger_error('No Datebase Set', E_USER_ERROR);
	}

	if (($use_sql = mysql_connect($mod_use->sql[0], $mod_use->sql[1], $mod_use->sql[2], true)) === false)
	{
		trigger_error('Cannot connect to SQL Server', E_USER_ERROR);
	}
	checkDB($mod_use->sql[3], $use_sql);
	if (mysql_select_db($mod_use->sql[3], $use_sql) === false)
	{
		trigger_error('Error Setting Database', E_USER_ERROR);
	}
	$modules_defaults['sql'] = $use_sql;
	if ($mod_use->exportsql) $sql = $use_sql;

	mod_charset($mod_use->charset, $sql, $mod_use->charsetheader);

	if (count($mod_use->autoindexes) ||$mod_use->autojava)
	{
		$modules_defaults['defaultlink'] = '?';
		mod_do_autoindexes($mod_use->autoindexes);
	}

	if (!isset($modules_defaults['defaultlink']))
	{
		$modules_defaults['defaultlink'] = mod_getStdDefaultLink();
	}

	if ($mod_use->changelink)
	{
		$modules_defaults['defaultlink'] .= '&mod_link=' . (isset($_REQUEST['mod_link']) ? ($_REQUEST['mod_link'] + 1) : 0);
	}

	if ($mod_use->user !== false)
	{
		$user = new user;
		mod_doDefaults($user, $mod_use->userdefaultdata, true);
		$user->table = $mod_use->user;
		$user->sessiontable = $mod_use->session;
		if ($user->groups = $mod_use->groups)
		{
			$user->grouplinktable = $mod_use->grouplinktable;
		}
		$user->relations = array_merge($user->relations, $mod_use->userrelations);
		$user->alwayssession = $mod_use->alwayssession;
		$user->sessiondata = $mod_use->sessiondata;
		$user->rights = $mod_use->rights;
		$user->globaldata = $mod_use->globaldata;
		$user->userdata = $mod_use->userdata === 1 && $mod_use->globaldata !== false ? $mod_use->globaldata : $mod_use->userdata;
		$user->counter = $mod_use->counter;
		if ($mod_use->usertimeout !== false) $user->timeout = $mod_use->usertimeout;
		$user->savedelete = $mod_use->usersavedelete;
		$user->adminrights = $mod_use->adminrights;
		$user->protectadminrights = $mod_use->protectadminrights;
		$user->protectadminuser = $mod_use->protectadminuser;
		$user->protectuser = $mod_use->protectuser;
		$user->limitadmin = $mod_use->limitadmin;
		$user->alias = $mod_use->useralias;
		$user->ssllogin = $mod_use->ssllogin;
		if (count($user->adddefaultlink) == 0)
		{
			$user->adddefaultlink = array_keys($mod_use->autoindexes);
			if ($mod_use->menu !== false) $user->adddefaultlink[] = "mod_setmenu$mod_dwMenuInstance";
		}

		$txt_login = CreateUserLogin($user);
		$modules_defaults['defaultlink'] .= $user->addlink;

		if ($mod_use->shop)
		{
			$user->relations += array(
				'company' => array('name' => $mod_txt['shop_user_company'], 'subtable' => 'adresses'),
				'forename' => array('name' => $mod_txt['shop_user_forename'], 'force' => true, 'subtable' => 'adresses'),
				'surname' => array('name' => $mod_txt['shop_user_surname'], 'force' => true, 'subtable' => 'adresses'),
				'street' => array('name' => $mod_txt['shop_user_street'], 'force' => true, 'subtable' => 'adresses'),
				'zip' => array('name' => $mod_txt['shop_user_zip'], 'group' => true, 'type' => 'int', 'force' => true, 'subtable' => 'adresses'),
				'city' => array('name' => $mod_txt['shop_user_city'], 'group' => false, 'force' => true, 'subtable' => 'adresses'),
				'tel' => array('name' => $mod_txt['shop_user_tel'], 'subtable' => 'contacts'),
				'fax' => array('name' => $mod_txt['shop_user_fax'], 'subtable' => 'contacts')
			);
			$user->editdata['subtables'] = array(
				'adresses' => array('id' => 'adress_id', 'type' => 'reverse'),
				'contacts' => array('id' => 'contact_id', 'type' => 'reverse', 'idtable' => 'adresses', 'defaults' => array('email' => ''))
			);
		}
	}

	mod_do_autoindexes($mod_use->userautoindexes[$userdata['id'] ? 0 : 1]);

	if ($mod_use->template !== false)
	{
		$template = new template;
		if ($mod_use->template !== true) $template->sqltablename = $mod_use->template;
		$template->vars = array('txt_pre', 'txt_menu', 'txt_login', 'txt_msg', 'txt_main', 'txt');
		mod_doDefaults($template, $mod_use->templatedata, true);
		PrepareTemplate($template);
	}

	if (!$mod_use->nolayout) mod_ExportCss(true);

	if ($mod_use->language !== false)
	{
		mod_ExportJavaLanguage(true);
	}

	if ($mod_use->autojava)
	{
		$modules_defaults['defaultlink'] .= AutoJavaTable($mod_use->user !== false ? $user->addlink : false);
		$mod_use->javaavailable = isset($_REQUEST['mod_java']) && $_REQUEST['mod_java'];
	}

	if ($mod_use->user !== false)
	{
		$user->addlink = '';
		$user->defaultlink = false;
	}

	if ($mod_use->log !== false)
	{
		$log = new logaccess;
		mod_doDefaults($log, $mod_use->logdefaultdata, true);
		$log->logtable = $mod_use->log;
		$log->paramtable = $mod_use->logparam;
		$log->usertable = $mod_use->user;
		if ($mod_use->log_param_name !== false)
		{
			$log->useparam = is_callable($mod_use->log_param_name) ? call_user_func($mod_use->log_param_name) :  $_REQUEST[$mod_use->log_param_name];
		}
		foreach ($mod_use->autoindexes as $index => $def) $log->nolog[$index] = 0;
		AddLog($log);
	}

	if ($mod_use->menu !== false)
	{
		$menu = new menu;
		$menu->table = $mod_use->menu;
		if ($mod_use->menuhtml !== false) $menu->html = $mod_use->menuhtml;
		$menu->permissiondenied = $mod_use->menupermissiondenied;
		if ($mod_use->javaavailable)
		{
			$menu->javamenu = ($mod_use->javamenu !== false);
			$menu->javasql = ($mod_use->javamenu !== false);
		}
		else
		{
			$menu->javamenu = $menu->javasql = false;
		}
		$menu->checkrights = true;
		$menu->preurlopt = $mod_use->menupreurl;
		if ($menu->multilanguage = $mod_use->menulan)
		{
			$menu->language = $mod_use->language;
		}
	
		mod_doDefaults($menu, $mod_use->menudefaultdata, true);
		$txt_menu = CreateMenu($menu, -1, 0, false, -2);
		if (count($txt_menu) > 1 || $menu->submenu_count)
		{
			$txt_menu[0] = ob_get_contents() . $txt_menu[0];
		}
		else
		{
			$txt_menu = ob_get_contents() . implode('', $txt_menu);
		}
		ob_clean();
		$menu->defaultlink = false;
		$modules_defaults['defaultlink'] .= $menu->addlink;
		$menu->addlink = '';

		$menuconfig = new menuconfig;
		mod_doDefaults($menuconfig, $mod_use->menuconfigdefaultdata, true);
		$menuconfig->table = $mod_use->menu;
		$menuconfig->rights = $mod_use->rights;
		$menuconfig->java = $mod_use->javaavailable ? $mod_use->javamenu : false;
		$menuconfig->multilanguage = $mod_use->menulan;
		if ($mod_use->menueditrights) $menuconfig->editrights = $mod_use->menueditrights;
	}

	mod_GenerateStdArray();
}

function mod_use_end()
{
	global $mod_use, $user, $menu, $menuconfig, $modules_defaults, $txt_main, $mod_msg, $txt_msg, $userdata, $modules_rights;
	if (!isset($mod_use)) return;
	if ($mod_use->user !== false && $user->sessiondata)
	{
		SaveSession($user);
	}

	if ($mod_use->autosetup)
	{
		$esRights = mysql_escape_string($mod_use->rights);
		$reqRights = 0;
		foreach ($mod_use->adminrights as $adminright)
		{
			$query = "SELECT right_id FROM `$esRights` WHERE name = '" . mysql_escape_string($adminright) . "'";
			if (mysql_num_rows($result = mod_mysql_querya($query, $modules_defaults['sql'])) == 0)
			{
				$norightsexist = true;
				CreateRightsEdit($user);
				break;
			}
			$reqRights ^= intval(mysql_result($result, 0));
		}

		if (!isset($norightsexis))
		{
			$query = "SELECT COUNT(*) FROM user WHERE (rights & $reqRights) = $reqRights";
			if ($mod_use->usersavedelete) $query .= ' AND deleted = 0';
			if (mysql_result(mod_mysql_querya($query, $modules_defaults['sql']), 0) == 0)
			{
				foreach ($mod_use->protectadminuser as $right)
				{
					if (isset($modules_rights[$right])) $userdata['rights'] |= $modules_rights[$right];
				}
				CreateUserEdit($user);
			}
		}

		if ($mod_use->menu)
		{
			$query = "SELECT COUNT(*) FROM `" . mysql_escape_string($mod_use->menu) . "`";
			if (mysql_result(mod_mysql_querya($query, $modules_defaults['sql']), 0) == 0)
			{
				CreateMenuConfig($menuconfig);
			}
		}
	}

	global $modules_onevents;
	mod_CreateJavaEvents();

	mysql_close($modules_defaults['sql']);

	$txt_main = ob_get_clean();

	if (isset($_REQUEST['mod_msg']))
	{
		$mod_msg[] = $_REQUEST['mod_msg'];
	}
	$txt_msg = (count($mod_msg) ? ('<font style="color:red;font-wight:bold;font-size:120%;"><b>' . implode('<br>', $mod_msg) . '</b></font><br><br>') : '');
}

function mod_use_redir($location = 'index.php')
{
	while (ob_get_level()) ob_end_clean();
	die("<script>document.location.href='" . AddSlashes($location) . "';</script>");
}

?>
